this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name = "Rescue Ambience";
this.description = "Adds occasional RRS-group flavour to this Ooniverse outside of (and around) missions";

//1.3 Add 6a mining bases to suitable systems
//1.3 handle generic blackboxes

this.timer1 = undefined; // plague 
this.timer2 = undefined; // no entry

/* One-off actions */

this.startUp = function() {
		this.updatePlanetInfo();

// Compatibility with other scripts that change system details.
// Specifically, leave Lezaer to us.
// System Redux
		if (worldScripts["System Redux"]) {
				if (worldScripts["System Redux"].startUp) {
						// make sure this has started first
						worldScripts["System Redux"].startUp();
				}
				worldScripts["System Redux"].changeSystems([[],[],[5],[],[],[],[],[]]);
		}
// System Demux
		if (worldScripts["System Demux"]) {
				if (!worldScripts["System Demux"].firstLaunch) {
						worldScripts["System Demux"].startUp();
				}
				worldScripts["System Demux"].system_info[517] = 0x0000; // 256*2 + 5
		}
// Deep Horizons Systems
		if (worldScripts["SystemRedux2API"]) {
				worldScripts["SystemRedux2API"].excludeSystem(2,5,{TextureMP:"true", AddPlanets:"true", AddMoons:"true", TxtPlanets:"true", TxtMoons:"true", ReduSun:"false"});
		}
		if (worldScripts["Deep Horizon - Systems API"]) {
			worldScripts["Deep Horizon - Systems API"].excludeSystem(2,5,{TextureMP:"true", AddPlanets:"true", AddMoons:"true", TxtPlanets:"true", TxtMoons:"true", ReduSun:"true"});	
		}

}

this.playerEnteredNewGalaxy = function(gal) {
		this.updatePlanetInfo();
}

this.updatePlanetInfo = function() {
		hqsysid = worldScripts["Rescue Stations"].systemWithRescueHQStation();
		
		cdesc = System.infoForSystem(galaxyNumber,hqsysid).description;
		if (cdesc.indexOf("RRS") == -1) {
				System.infoForSystem(galaxyNumber,hqsysid).description = cdesc+" RRS Galactic Headquarters are in this system.";
		}
}


/* Each-system actions */


this.addAmbience = function() {
		if (system.isInterstellarSpace) {
				return;
		}
		// Plague Systems from 6a
		if (this.plagueActive()) {
				this.plagueSystem();
		}

		// System barring from diplomatic incidents
		if (missionVariables.rescuestation_noentry) {
				this.barredFromSystem();
		}
		// //// To avoid confusion the following should only appear outside missions
		if (!worldScripts["Rescue Stations"].missionActive()) {
				// potentially add a few generic black boxes to the space lanes
				this.blackBox();

				// asteroid fields from 1a and 3
				// because they should be there even if there isn't anything in them ;)				
				this.asteroidField();
		}
}

this.plagueActive = function() {
		if (system.info.description.indexOf("disease") == -1) {
				return false; // not a plague system
		}
		pstart = system.ID;
		plength = 128-(system.info.techlevel*8);
		day = clock.days % 384;
		return (day >= pstart && day <= pstart+plength);
}

this.plagueSystem = function() {
// slight delay to stop message being lost
		this.timer1 = new Timer(this,this.plagueSystemAux,6);
}

this.plagueSystemAux = function() {
		beacon = system.shipsWithRole("buoy-witchpoint");
		if (beacon.length > 0) {
				beacon[0].commsMessage("[rescue_plague_system]");
		}
}

this.asteroidField = function() {
		if (Math.random() < 0.05) {
				this.asteroidField1(); // scenario 3/3a style
		} else if (Math.random() < 0.05) {
				this.asteroidField2(); // scenario 1a style
		}
}

this.asteroidField1 = function() {
		fieldcentre = Vector3D(0,0,0.2+(Math.random()*0.3)).fromCoordinateSystem("wsu");
		fieldcentre.add(Vector3D.random(20E3));
		
		asteroids = 25+Math.floor(Math.random()*100);
		fieldradius = 1E3*(20+Math.random()*50);
		for (i=0;i<asteroids;i++) {
				apos = fieldcentre.add(Vector3D.randomDirectionAndLength(fieldradius));
				system.addShips("asteroid",1,apos,1E3);
		}
}

this.asteroidField2 = function() {
		dpos = Vector3D.randomDirection().multiply(60E3);
		cpos = dpos.add(Vector3D.random(5E3));
		asteroids = 50;
		fieldradius = 30E3;
		for (i=0;i<asteroids;i++) {
				apos = cpos.add(Vector3D.randomDirectionAndLength(fieldradius));
				aster = system.addShips("asteroid",1,apos,1E3);

				if (aster[0].position.distanceTo(dpos) > 20E3 && Math.random() < 0.5) {
						vel = dpos.subtract(aster[0].position);
						
						aster[0].velocity = vel.multiply((2+(Math.random()*9))/(5E3));
				}
		}

}

this.blackBox = function() {
		if (Math.random() < 0.5) {
				bb = system.addShipsToRoute("rescue_blackbox_generic",1,0.1+Math.random()*0.8,"wp");
				bb[0].velocity = Vector3D.randomDirection();
		}
// less on the quieter routes; too easy
		if (Math.random() < 0.1) {
				bb = system.addShipsToRoute("rescue_blackbox_generic",1,0.1+Math.random()*0.7,"ws");
				bb[0].velocity = Vector3D.randomDirection();
		}
		if (Math.random() < 0.1) {
				bb = system.addShipsToRoute("rescue_blackbox_generic",1,0.1+Math.random()*0.7,"ps");
				bb[0].velocity = Vector3D.randomDirection();
		}

}

this.barredFromSystem = function() {
		if (missionVariables.rescuestation_noentry == system.ID) {
				if (missionVariables.rescuestation_noentrytime > clock.days) {
						// nothing; something odd has happened
						delete missionVariables.rescuestation_noentry;
						delete missionVariables.rescuestation_noentrytime;
				} else {
						chance = clock.days-missionVariables.rescuestation_noentrytime;
						if (chance < Math.random()*100) {
								this.timer2 = new Timer(this,this.barredFromSystemAux,6);
						} else {
								delete missionVariables.rescuestation_noentry;
								delete missionVariables.rescuestation_noentrytime;
								// got away with it.
						}
				}
		} else if (missionVariables.rescuestation_noentrytime + 100 < clock.days) {
				delete missionVariables.rescuestation_noentry;
				delete missionVariables.rescuestation_noentrytime;
				// lapsed, stop checking
		}
}

this.barredFromSystemAux = function() {
		beacon = system.shipsWithRole("buoy-witchpoint");
		if (beacon.length > 0) {
				beacon[0].commsMessage("[rescue_barred_system]");
		}
		this.timer2 = new Timer(this,this.barredFromSystemBaux,40);
}

this.barredFromSystemBaux = function() {
		if (missionVariables.rescuestation_noentry == system.ID) {
				// if not, they jumped out in time
				beacon = system.shipsWithRole("buoy-witchpoint");
				if (beacon.length > 0) {
						beacon[0].commsMessage("[rescue_barred_system2]");
				}
				player.bounty += 20;
		}
}

//generic blackboxes handling

this.$blackboxes = new Array();

//notify player that a black box has been scooped
//add scooped black box to an array
this.shipScoopedOther = function(whom) {
	if (whom.primaryRole === "rescue_blackbox_generic") {
		player.consoleMessage("Return the black box to any station for a reward.", 5);
		this.$blackboxes.push(whom);
	}
}

//cash the loot
this.shipWillDockWithStation = function(station) {
	for (var i = 0; i < this.$blackboxes.length; i++) {
		if (this.$blackboxes[i].status === "STATUS_IN_HOLD") {
			var payment = 25+Math.floor(50*Math.random());
			var message = "For recovering the black box of the [rescue_random_shipname], insurance pays "+payment+" Cr.";
			missionVariables.rescuestation_reputation++;
			player.credits += payment;
			player.addMessageToArrivalReport(expandDescription(message));
			if (manifest.machinery > 0) manifest.machinery--;
		}
	}
	this.$blackboxes = new Array();
}
