this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.2.4"; 
this.name = "Rescue Autopilot";
this.description = "The world script for the RRS escort autopilot";

this.hopsize = 5E3;
this.callback = undefined;
this.screen = undefined;

this.findAnything = function(entity) {
		return !entity.hasRole("alloy"); // anything but the reference object
}

this.findDangerous = function(entity) {
// we're being quite conservative, so dangerous *to who* isn't being considered.
		return (entity.isShip && (entity.hasHostileTarget || entity.isWeapon || entity.isPirate || entity.isThargoid)) || entity.isStation;
}

this.findDangerous2 = function(entity) {
// things that are only dangerous to offenders
		return (entity.isShip && (entity.isPolice || entity.scanClass == "CLASS_MILITARY" || entity.primaryRole == "hunter"));
}


this.autopilotStep = function(ship) {
		if (!ship.isValid) {
				return;
		}
		if (!ship.script.autopilotwilling) {
				return;
		}
		
		// Firstly, check if we're there yet.
		if (ship.savedCoordinates.distanceTo(ship.position) < 20E3) {
				
				ship.reactToAIMessage("DESTINATION_NEAR");
				return;
		}

    // then check if we can safely make the next hop.
		nextjump = ship.vectorForward.multiply(5E3);
		nexthoppos = ship.position.add(nextjump);
		alloy = system.addShips("alloy",1,nexthoppos,1)[0];
		if (system.filteredEntities(this,findAnything,alloy,hopsize/2).length > 0) {
				ship.reactToAIMessage("OBSTACLES_NEAR");
				alloy.remove(true);
				return;
		}
		alloy.remove(true);

		// then check if we can safely do so
		if (system.filteredEntities(this,findDangerous,ship,25600).length > 0) {
				ship.reactToAIMessage("HOSTILES_NEAR");
				return;
		}

		if (ship.bounty > 0 || player.bounty > 0) {
				if (system.filteredEntities(this,findDangerous2,ship,25600).length > 0) {
						ship.reactToAIMessage("HOSTILES_NEAR");
						return;
				}
		}

		// okay, make the next hop

		ship.position = ship.position.add(nextjump);
		player.ship.position = player.ship.position.add(nextjump);
		player.ship.orientation = ship.orientation;
		player.ship.velocity = ship.velocity;
		if (ship.escorts) {
				for (i=0;i<ship.escorts.length;i++) {
						ship.escorts[i].position = ship.escorts[i].position.add(nextjump);
				}
		}
		extras = system.shipsWithRole("rrs-flightcomp-aux",ship,15E3);
		for (i=0;i<extras.length;i++) {
				extras[i].position = extras[i].position.add(nextjump);
		}

		adjustment = hopsize/ship.speed;

		clock.addSeconds(adjustment);
		
}


