this.author      = "cim, spara"; 
this.copyright   = "� 2011-2012 cim. 2014 spara"; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.4"; 
this.name        = "Rescue Stations"; 
this.description = "This script adds rescue stations and rescue missions. (main script for OXP)"; 

this.lastmissiongen = 0;
this.scenarios = new Array();
this.variantscenarios = new Array();
this.availablescenarios = new Array();
this.missionpointer = 0;
this.runonce = 0;
this.missionlog = new Object();

this.testmode = "";

this.startUp = function() {
		if (!missionVariables.rescuestation_stage) {
				// first run
				missionVariables.rescuestation_stage = 0;
		}
		if (!missionVariables.rescuestation_reputation) {
				// first run
				missionVariables.rescuestation_reputation = 0;
		}
		if (!missionVariables.rescuestation_prevreputation) {
				missionVariables.rescuestation_prevreputation = 0;
		}
		if (!missionVariables.rescuestation_firstconv) {
				// first run
				missionVariables.rescuestation_firstconv = 0;
		}
		if (!missionVariables.rescuestation_missionlog) {
				// first run
				missionVariables.rescuestation_missionlog = "";
		} else {
				missionlogs = missionVariables.rescuestation_missionlog.split(";");
				for (i=0;i<missionlogs.length;i++) {
						missiondata = missionlogs[i].split("=");
						this.missionlog[missiondata[0]] = missiondata[1];
				}
				this.syncMissionLog();
		}

		this.lastmissiongen = clock.hours-1;
		
		this.tryAddingRescueStation(true);

		delete this.startUp;
}

this.startUpComplete = function() {
	
	if (player.ship.dockedStation.hasRole("rescue_station") && missionVariables.rrs_available_scenarios) {
		this.availablescenarios_save = JSON.parse(missionVariables.rrs_available_scenarios);
		this.lastmissiongen = clock.hours;
		this.fillMissionBoard();
	}
}

this.registerScenario = function(sckey) { // register basic scenarios
		this.scenarios.push(sckey);

// transfer old-style variables
		if (missionVariables["rescuestation_scenario_"+sckey+"_complete"]) {
				this.missionlog[sckey+"_complete"] = missionVariables["rescuestation_scenario_"+sckey+"_complete"];
 		}
		delete missionVariables["rescuestation_scenario_"+sckey+"_complete"];

}

this.registerVariant = function(origkey,sckey) { // register variant scenarios
		vdesc = new Array();
		vdesc.push(origkey);
		vdesc.push(sckey);

		this.variantscenarios.push(vdesc);

// transfer old-style variables
		if (missionVariables["rescuestation_scenario_"+sckey+"_complete"]) {
				this.missionlog[sckey+"_complete"] = missionVariables["rescuestation_scenario_"+sckey+"_complete"];
		}
		delete missionVariables["rescuestation_scenario_"+sckey+"_complete"];

}

this.syncMissionLog = function() {
		mlogs = new Array();
		for (key in this.missionlog) {
				mlogs.push(key+"="+this.missionlog[key]); 
		}
		missionVariables.rescuestation_missionlog = mlogs.join(";");
}

this.scenariosWon = function(sckey) {
		if (this.missionlog[sckey+"_complete"]) {
				return this.missionlog[sckey+"_complete"];
		} else {
				return 0;
		}
}

this.scenariosLost = function(sckey) {
		if (this.missionlog[sckey+"_failed"]) {
				return this.missionlog[sckey+"_failed"];
		} else {
				return 0;
		}
}

this.scenariosTried = function(sckey) {
		return this.scenariosWon(sckey)+this.scenariosLost(sckey);
}

/* Event handlers */
this.playerWillSaveGame = function() {
	this.syncMissionLog();
	if (player.ship.dockedStation.hasRole("rescue_station") && this.availablescenarios_save) {
		missionVariables.rrs_available_scenarios = JSON.stringify(this.availablescenarios_save);
	}
}

this.shipWillExitWitchspace = function() {
	
		this.tryAddingRescueStation(false);

		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipWillExitWitchspace) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipWillExitWitchspace();
		}
// reputation won't appear until at least one mission at least considered
		if (missionVariables.rescuestation_reputation > 400) { // cap at 400
				missionVariables.rescuestation_reputation = 400;
				if (!this.missionActive()) {
						this.setMissionDetails(this.reputationString());
				}
		} else if (missionVariables.rescuestation_reputation > 0) {
				for (i=0;i<missionVariables.rescuestation_reputation;i+=20) {
						// lose one rank point for every 20 owned while not on a mission
						// need to do more difficult missions at higher ranks to get a promotion
						if (!this.missionActive()) {
								if (missionVariables.rescuestation_reputation == 10 ||
										missionVariables.rescuestation_reputation == 20 ||
										missionVariables.rescuestation_reputation == 40 ||
										missionVariables.rescuestation_reputation == 80 ||
										missionVariables.rescuestation_reputation == 160 ||
										missionVariables.rescuestation_reputation == 320) {
										// nothing: general decay won't reduce rank
								} else {
										missionVariables.rescuestation_reputation--;
								}
						} // no general decay if on a mission
						if (player.bounty > 0) {
								missionVariables.rescuestation_reputation--;
								if (player.bounty > 50) {
										missionVariables.rescuestation_reputation--;
								}
						}
				}
				if (!this.missionActive()) {
						this.setMissionDetails(this.reputationString());
				}
		} else if (missionVariables.rescuestation_reputation < 0 && player.bounty == 0) {
				missionVariables.rescuestation_reputation++;
				if (!this.missionActive()) {
						this.setMissionDetails(this.reputationString());
				}
		} else if (missionVariables.rescuestation_reputation > -30 && player.bounty >= 50) {
				missionVariables.rescuestation_reputation--; // fugitives can take a while to be trusted again
		}
}

this.shipExitedWitchspace = function () { 
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipExitedWitchspace) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipExitedWitchspace();
		}

}

this.shipWillLaunchFromStation = function (rstation) { 
		if (this.saveAnywhere()) {
				return; // ignore on Save-Anywhere usage
		}

		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipWillLaunchFromStation) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipWillLaunchFromStation(rstation);
		}
		//remove interface when launching
		player.ship.dockedStation.setInterface("rescue_station",null);
}

this.shipDockedWithStation = function(rstation) {
		if (this.saveAnywhere()) {
				return; // ignore on Save-Anywhere usage
		}
		this.missionpointer = 0; //reset bulletin pointer
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipDockedWithStation) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_shipDockedWithStation(rstation);
		} else if (rstation.hasRole("rescue_station")) {
				this.fillMissionBoard();
		}
}

this.guiScreenChanged = function(to, from) {
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_guiScreenChanged) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_guiScreenChanged(to, from);
		}
/*
		if (player.ship.docked && player.ship.dockedStation.hasRole("rescue_station") && guiScreen === "GUI_SCREEN_STATUS") {
				//add interface when there are missions.
		}
*/
}

this.solarLabReactionComplete = function () { 
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabReactionComplete) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabReactionComplete();
		}

}

this.solarLabCollected = function (scooper) { 
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabCollected) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabCollected(scooper);
		}

}

this.solarLabDeployed = function () { 
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabDeployed) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabDeployed();
		}

}


this.solarLabDestroyed = function () { 
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabDestroyed) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_solarLabDestroyed();
		}

}


this.missionScreenOpportunity = function() {
		if (this.saveAnywhere()) {
				return;
		}
/*		// TESTING
		systemlist = new Array();
		for (i=0;i<=255;i++) {
				si = System.infoForSystem(galaxyNumber,i);
				sr = this.rrsRandom(galaxyNumber,i);
				if ((si.government == 7 && sr < 0.75) || 
						(si.government == 6 && sr < 0.5) || 
						(si.government == 5 && sr < 0.25)) {
						systemlist.push(si.name);
				}
		}
		systemlist.sort();
		systemliststr = " "+systemlist.length+" : "+systemlist.join(", ");
		mission.runScreen ({title: "Local stations",
														message: systemliststr});
		log(this.name,"Gal"+galaxyNumber+":"+systemliststr);
		return; */
		
		if (player.ship.dockedStation.hasRole("rescue_station") && missionVariables.rescuestation_firstconv == 0) {
				missionVariables.rescuestation_firstconv = 1;
				mission.runScreen ({title: "Welcome to RRS",
														messageKey: "rescue_welcome_screen",
														model: "rescue_station",
														background: "rrsfl_blank_bg.png"
														});

				
		} 
		else if (player.ship.dockedStation.hasRole("rescue_station") && this.hasRankIncreased()) {
				mission.runScreen ({title: "Congratulations, Commander",
														messageKey: "rescue_promotion_screen_"+this.hasRankIncreased(),
														model: "rescue_station",
														background: "rrsfl_blank_bg.png"
														});
				missionVariables.rescuestation_prevreputation = missionVariables.rescuestation_reputation;

		} else {

				if (missionVariables.rescuestation_stage > 0) {
						if (worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_missionScreenOpportunity) {
								worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_missionScreenOpportunity();
						}
				}
				
				 else if (this.availablescenarios.length > 0 && player.ship.dockedStation.hasRole("rescue_station")) {
						if (this.availablescenarios.length == 1) {
								ckey = "rescue_mission_intro_choice_last";
						} else {
								ckey = "rescue_mission_intro_choice";
						}

						if (this.missionpointer >= this.availablescenarios.length) {
								this.missionpointer = 0;
						}

						mission.runScreen ({title: "RRS Contracts ("+(this.missionpointer+1)+"/"+this.availablescenarios.length+")" ,
																messageKey: "rescue_scenario_"+this.availablescenarios[this.missionpointer]+"_synopsis",
																choicesKey: ckey,
																model: "rescue_station",
																background: "rrsfl_blank_bg.png"
																},
															 this.examineMission);
						

				}
				
		}
}

this.playerEnteredNewGalaxy = function() {
		if (this.missionActive()) {
				this.failMission();
				player.consoleMessage("You have abandoned your RRS Group assignment",10);
		}
		delete missionVariables.rescuestation_noentry;
		delete missionVariables.rescuestation_noentrytime;
}

this.playerBoughtEquipment = function(equipment) {
		if (equipment == "EQ_RRS_FUEL") {
				player.ship.removeEquipment("EQ_RRS_FUEL");
				player.ship.fuel = 7;
		} else if (equipment == "EQ_RRS_SCOOPS") {
				player.ship.removeEquipment("EQ_RRS_SCOOPS");
				if (player.ship.canAwardEquipment("EQ_FUEL_SCOOPS")) {
						player.ship.awardEquipment("EQ_FUEL_SCOOPS");
				} else {
						player.consoleMessage("Sorry: your ship doesn't have anywhere we can fit fuel scoops.");
						player.credits += 472.5;
				}
		} else if (equipment == "EQ_RRS_SCANNER_SHOW_MISSILE_TARGET") {
				player.ship.removeEquipment("EQ_RRS_SCANNER_SHOW_MISSILE_TARGET");
				if (player.ship.canAwardEquipment("EQ_SCANNER_SHOW_MISSILE_TARGET")) {
						player.ship.awardEquipment("EQ_SCANNER_SHOW_MISSILE_TARGET");
				} else {
						player.consoleMessage("Sorry: your ship doesn't have anywhere we can fit a Scanner Targeting Enhancement.");
						player.credits += 900;
				}
		} else if (equipment == "EQ_RRS_SCANNER_SHOW_MISSILE_TARGET_DISCOUNT") {
				player.ship.removeEquipment("EQ_RRS_SCANNER_SHOW_MISSILE_TARGET_DISCOUNT");
				if (player.ship.canAwardEquipment("EQ_SCANNER_SHOW_MISSILE_TARGET")) {
						player.ship.awardEquipment("EQ_SCANNER_SHOW_MISSILE_TARGET");
				} else {
						player.consoleMessage("Sorry: your ship doesn't have anywhere we can fit a Scanner Targeting Enhancement.");
						player.credits += 405;
				}

		} else if (equipment == "EQ_RRS_DOCK_COMP") {
				player.ship.removeEquipment("EQ_RRS_DOCK_COMP");
				if (player.ship.canAwardEquipment("EQ_DOCK_COMP")) {
						player.ship.awardEquipment("EQ_DOCK_COMP");
				} else {
						player.consoleMessage("Sorry: your ship's systems are incompatible with the docking computer software.");
						player.credits += 1350;
				}
		} else if (equipment == "EQ_RRS_ASC") {
				player.ship.removeEquipment("EQ_RRS_ASC");
				player.ship.awardEquipment("EQ_ADVANCED_COMPASS");
		} else if (equipment == "EQ_RRS_ANA") {
				player.ship.removeEquipment("EQ_RRS_ANA");
				player.ship.awardEquipment("EQ_ADVANCED_NAVIGATIONAL_ARRAY");
		} else if (equipment == "EQ_RRS_HEAT_SHIELD") {
				player.ship.removeEquipment("EQ_RRS_HEAT_SHIELD");
				player.ship.awardEquipment("EQ_HEAT_SHIELD");
		} else if (equipment == "EQ_RRS_DOCK_COMP") {
				player.ship.removeEquipment("EQ_RRS_DOCK_COMP");
				player.ship.awardEquipment("EQ_DOCK_COMP");
		} else if (equipment == "EQ_RRS_FLIGHTFORM") {
				player.ship.removeEquipment("EQ_RRS_FLIGHTFORM_DISCOUNT");
				player.ship.awardEquipment("EQ_RRS_FLIGHTFORM");
		} else if (equipment == "EQ_RRS_ESCORT_TARGETING_SYSTEM_DISCOUNT") {
				player.ship.removeEquipment("EQ_RRS_ESCORT_TARGETING_SYSTEM_DISCOUNT");
				player.ship.awardEquipment("EQ_RRS_ESCORT_TARGETING_SYSTEM");
		} else if (equipment == "EQ_RRS_ESCORT_TARGETING_SYSTEM_WAYSTATION") {
				player.ship.removeEquipment("EQ_RRS_ESCORT_TARGETING_SYSTEM_WAYSTATION");
				player.ship.awardEquipment("EQ_RRS_ESCORT_TARGETING_SYSTEM");


		} else if (equipment == "EQ_RRS_SERVICE") {
				player.ship.removeEquipment("EQ_RRS_SERVICE");
				repairable = ["EQ_FUEL_SCOOPS",
											"EQ_ECM",
											"EQ_ESCAPE_POD",									
											"EQ_ENERGY_UNIT",
											"EQ_DOCK_COMP",
											"EQ_GAL_DRIVE",
											"EQ_FUEL_INJECTION",
											"EQ_SCANNER_SHOW_MISSILE_TARGET",
											"EQ_MULTI_TARGET",
											"EQ_ADVANCED_COMPASS",
											"EQ_ADVANCED_NAVIGATIONAL_ARRAY",
											"EQ_TARGET_MEMORY",
											"EQ_HEAT_SHIELD",
											"EQ_WORMHOLE_SCANNER",
											"EQ_FRAME_BOUNTY_SCANNER",
											"EQ_ESCAPE_CAPSULE_LOCATOR",
											"EQ_PLANETFALL",
											"EQ_ROCKHERMIT_SCANNER",
											"EQ_AUTO_EJECT",
											"EQ_BREAKABLE_HUD_IFF_SCANNER",
											"EQ_BREAKABLE_SHIELD_FORE",
											"EQ_BREAKABLE_SHIELD_AFT",
											"EQ_BREAKABLE_TORUSDRIVE",
											"EQ_BREAKABLE_WITCHDRIVE",
											"EQ_FRAME_FUEL_COLLECTOR",
											"EQ_ELECTRONIC_THUMB",
											"EQ_RRS_FLIGHTFORM",
											"EQ_RRS_ESCORT_TARGETING_SYSTEM"
										 ];
				repaired = 0;
				for (i=0;i<repairable.length;i++) {
						repair = repairable[i];
						if (player.ship.equipmentStatus(repair) == "EQUIPMENT_DAMAGED") {
								repaired++;
								player.ship.setEquipmentStatus(repair,"EQUIPMENT_OK");
						}
				}
				if (repaired > 0) {
						clock.addSeconds(86400);
				} else {
						player.consoleMessage("Your ship doesn't appear to have any damaged equipment that we can repair.");
						player.credits += 500;
				}
		} else if (equipment == "EQ_RRS_FULLEQUIP") {
				player.ship.removeEquipment("EQ_RRS_FULLEQUIP");
				rrsequips = ["EQ_SCANNER_SHOW_MISSILE_TARGET","EQ_FUEL_SCOOPS","EQ_ADVANCED_COMPASS","EQ_ADVANCED_NAVIGATIONAL_ARRAY","EQ_HEAT_SHIELD","EQ_DOCK_COMP","EQ_RRS_FLIGHTFORM","EQ_RRS_ESCORT_TARGETING_SYSTEM"];
				added = 0;
				for (i=0;i<rrsequips.length;i++) {
						equip = rrsequips[i];
						if (player.ship.canAwardEquipment(equip)) {
								player.ship.awardEquipment(equip);
								added++;
						}
				}
				if (added == 0) {
						player.consoleMessage("Your ship is already equipped to RRS standards.");
						player.credits += 1000;
				} else {
						clock.addSeconds(86400);
				}
		}

}

/* Mission selection functions */

this.fillMissionBoard = function () {
		if (this.lastmissiongen < clock.hours) { // stop people just launching and re-entering to reset missions
				this.missionpointer = 0;
				this.availablescenarios = new Array();
				this.availablescenarios_save = new Array();
				this.usedreplacements = new Array();
				this.variantscenarios.sort(function(a,b) { return Math.random()-0.5; }); // shuffle order so it isn't always the same variant being checked first

				if (this.testmode == "") {
						for (i=0;i<this.scenarios.length;i++) {
								if (worldScripts["Rescue Scenario "+this.scenarios[i]].missionAvailable()) {
										for (j=1;j<=worldScripts["Rescue Scenario "+this.scenarios[i]].missionAvailableCount();j++) {
												scode = this.scenarios[i];
												replaced = false;
												for(k=0;k<this.variantscenarios.length && !replaced;k++) {
														vcode = this.variantscenarios[k][1];
														if (usedreplacements.indexOf(vcode) == -1) { // not used this replacement already
																if (this.variantscenarios[k][0] == scode) {
																		if (worldScripts["Rescue Scenario "+vcode].missionAvailable()) {				
																				scode = vcode; // replace the scenario
																				replaced = true;
																				usedreplacements.push(vcode);
																		}
																}
														}
												}
												this.availablescenarios.push(scode);
										}
								}
						}
				} else {
						this.availablescenarios.push(this.testmode);
				}
				if (this.availablescenarios.length > 1) {
						this.availablescenarios.sort(function(a,b) { return Math.random()-0.5; }); // shuffle order
				}
				this.lastmissiongen = clock.hours;
		}
		else {
			//restore previous list of contracs
			this.availablescenarios = this.availablescenarios_save.concat();
		}
		//add station interface
		if (this.availablescenarios.length > 0)
			this.$addInterface();
		else player.ship.dockedStation.setInterface("rescue_station",null);
		
		this.availablescenarios_save = this.availablescenarios.concat();
		this.availablescenarios = new Array();
}
		
this.examineMission = function(choice) {
		if (choice == "2YES") {
			this.initMissionVariables(this.availablescenarios[this.missionpointer]);
		} else if (choice == "1NO") {
				this.missionpointer++;
		} else if (choice == "3LEAVE") {
			//create secondary board to restore board when needed
			this.availablescenarios_save = this.availablescenarios.concat();
			//clear the primary board
			this.availablescenarios = new Array();
		}
}

// f4 interface 
this.$addInterface = function() {
	player.ship.dockedStation.setInterface("rescue_station",{
		title: "RRS contract board",
		category: "Contracts",
		summary: "Enter Rescue, Recovery and Salvage Station contract board.",
		callback: this.$showInterface.bind(this)
	});
};

this.$showInterface = function() {
	//restore secondary board to primary board
	this.availablescenarios = this.availablescenarios_save.concat();
	this.missionpointer = 0; //reset bulletin pointer
	this.missionScreenOpportunity(); //show board
};

/* Utility functions */

this.saveAnywhere = function() {

		if ((missionVariables.framesave == "MoveToOxpStation") || (missionVariables.framesave == "MoveToMainStation")) {
				return true; // ignore on Save-Anywhere usage
		}
		return false;

}

this.setMissionDetails = function(details) {
		mission.setInstructionsKey(details);
}

this.missionActive = function () {
		return (missionVariables.rescuestation_scenario && (missionVariables.rescuestation_stage > 0));
}

this.systemHasRescueStation = function(sysid) {
		gov = System.infoForSystem(galaxyNumber,sysid).government;
		
		if (this.testmode != "") {
				return (gov >= 5);
		}
		

		chance = this.rrsRandom(galaxyNumber,sysid);

		return ((gov == 7 && chance < 0.75) || // 75% corporate
						(gov == 6 && chance < 0.5) || // 50% democracy
						(gov == 5 && chance < 0.25)); // 25% confederacy
}

this.systemWithRescueHQStation = function() {
		switch (galaxyNumber) {
		case 0:
				hqsysid = 237; // Aruszati
				break;
		case 1:
				hqsysid = 98; // Laribebi
				break;
		case 2:
				hqsysid = 5; // Lezaer
				break;
		case 3:
				hqsysid = 149; // Teance
				break;
		case 4:
				hqsysid = 35; // Enuserin
				break;
		case 5:
				hqsysid = 213; // Larivear
				break;
		case 6:
				hqsysid = 66; // Maraus
				break;
		case 7:
				hqsysid = 7; // Vegedius
				break;
		}
		return hqsysid;
}

this.systemHasRescueHQStation = function(sysid) {
		if (this.testmode == "HQ") {
				return true;
		}
		hqsysid = this.systemWithRescueHQStation();
		return (sysid == hqsysid);
}

this.systemWillPopulate = function (){
	
	//waystations
	if (this.systemHasRescueStation(system.ID)) {
		//allow spawning of a destroyed station if on a mission.
		if (this.missionActive() || !(worldScripts.station_validator && (worldScripts.station_validator.$deaths("rescue_station").length !== 0))) {
			var sposc1 = system.mainPlanet.position.multiply(0.5);
			var sposc2 = system.sun.position.direction().multiply(sposc1.magnitude());
			var rspos = Vector3D.interpolate(sposc1,sposc2,0.3);
			system.setPopulator("rrs_waystation", {
				callback: function(pos) {			
					var rescuestation = system.addShips("rescue_station",1,pos,0)[0];
					rescuestation.orientation = [1,0,0,0]; // align with primary axis

					var rbuoy = system.addShipsToRoute("rrs_pointer",1,0.5,"wp")[0];
					rbuoy.orientation = rescuestation.position.subtract(rbuoy.position).direction().rotationTo([0,0,1]);

					var rbuoy2 = system.addShipsToRoute("rrs_pointer",1,0.5,"ws")[0];
					rbuoy2.orientation = rescuestation.position.subtract(rbuoy2.position).direction().rotationTo([0,0,1]);
					
				}.bind(this),
				location: "COORDINATES",
				coordinates: rspos,
				deterministic: true
			})
		}
	}
	
	//HQ
	if (this.systemHasRescueHQStation(system.ID)) {
		var spawnSpot = system.sun.position.cross(system.mainPlanet.position).direction().multiply(500E3);
		//allow spawning of a destroyed hq if on a mission.
		if (this.missionActive() || !(worldScripts.station_validator && (worldScripts.station_validator.$deaths("rrs_galactic_hq").length !== 0))) {
			system.setPopulator("rrs_hq", {
				callback: function(pos) {
					system.addShips("rrs_galactic_hq", 1, pos, 0);					
				}.bind(this),
				location: "COORDINATES",
				coordinates: spawnSpot,
				deterministic: true
			})
		}
		//add asteroid field even if the station has been destroyed.
		system.setPopulator("rrs_hq_asteroids", {
			callback: function(pos) {
				for (var i=0; i<4; i++) {
					var asteroids = system.addShips("asteroid",64,spawnSpot,75E3);
					for (j=0; j<asteroids.length; j++) {
						if (asteroids[j].position.distanceTo(spawnSpot) < 15E3) {
							asteroids[j].remove(true);
						}
					}
				}
			}.bind(this),
			location: "COORDINATES",
			coordinates: spawnSpot
		})
	}
	
	//Mining bases
	
	//follow mission 6a guidelines when populating with mining base
	
	//potential system has to have disease in description. What is cause and what is effect? Who knows.
	if (!(!system.sun.hasGoneNova && (system.info.description.indexOf("disease") != -1))) {
		return;
	}
	
	//check that there is no 6a mission running to the current system
	if (missionVariables.rescuestation_scenario && (missionVariables.rescuestation_stage > 0) && (missionVariables.rescuestation_scenario === "6a") && (missionVariables.rescuestation_destsystem2 === system.ID)) {
		return;
	}
	
	//there has to be a suitable system nearby to provide meds in case of outbreak.
	//don't know if this will ever trigger though
	var medsSystems = SystemInfo.filteredSystems(this, function (other) {
				if (!((other.description.indexOf("disease") == -1) &&
							(!other.sun_gone_nova) &&
							(other.techlevel >= 11) &&
							(system.info.distanceToSystem(other) <= 45) && 
							(other.economy <= 1))) { // Rich/Avg industrials
								return false;
				} else {
						var route = system.info.routeToSystem(other);
						return (route && route.distance <= 45);
				}
	});
	if (medsSystems.length === 0) {
		return;
	}

	//Let's populate
	var i = 1;
	//find a suitable location
	do {
		var mineloc = Vector3D(system.scrambledPseudoRandomNumber(i), system.scrambledPseudoRandomNumber(i + 1), system.scrambledPseudoRandomNumber(i + 2)).multiply(400E3);
		i++;
	} while (mineloc.magnitude() < 100E3);
	//station validator support
	if (!(worldScripts.station_validator && (worldScripts.station_validator.$deaths("rrsfl-mining-outpost").length !== 0))) {
		system.setPopulator("rrs_mining_outpost", {
			callback: function(pos) {
					system.addShips("rrsfl-mining-outpost",1,pos,0);
			}.bind(this),
			location: "COORDINATES",
			coordinates: mineloc,
			deterministic: true
		});
	}
	//create the asteroid field
	system.setPopulator("rrs_mining_outpost_asteroids", {
		callback: function(pos) {
			system.addShips("asteroid", 30+Math.floor(Math.random()*40), pos, 40E3);
		}.bind(this),
		location: "COORDINATES",
		coordinates: mineloc
	});
	//add some miners
	system.setPopulator("rrs_mining_outpost_miners", {
		callback: function(pos) {
			system.addShips("miner",3,pos,20E3);
		}.bind(this),
		location: "COORDINATES",
		coordinates: mineloc
	});
	//there might be pirates lurking in the outskirts of the mine field
	var pirates = Math.round(Math.random()*(8 - system.government));
	if (pirates > 0) {
		//divide the pirates roughly into two groups
		//first group will be positioned between wp and mine
		var group1 = Math.ceil(pirates / 2);
		//OG = OM.direction * (|OM| - 55E3)
		var group1Location = mineloc.direction().multiply(mineloc.magnitude() - 55E3);
		system.setPopulator("rrs_mining_outpost_pirates1", {
			callback: function(pos) {
				system.addShips("pirate", group1, pos, 15E3);
			}.bind(this),
			location: "COORDINATES",
			coordinates: group1Location
		});
		if (pirates > group1) {
			//second group will be positioned between planet and mine
			var group2 = pirates - group1;
			//MP = OP - OM
			var m2p = system.mainPlanet.position.subtract(mineloc);
			//OG = OM + MP.direction * 55E3
			var group2Location = mineloc.add(m2p.direction().multiply(55E3));
			system.setPopulator("rrs_mining_outpost_pirates1", {
				callback: function(pos) {
					system.addShips("pirate", group2, pos, 15E3);
				}.bind(this),
				location: "COORDINATES",
				coordinates: group2Location
			});
		}
	}
}

this.tryAddingRescueStation = function(once) {
		if (once && this.runonce == 1) {
				return;
		}
		this.runonce = 1;
		
		if (this.missionActive() && worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_populatingSystem) {
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].rescue_populatingSystem();
		}
		worldScripts["Rescue Ambience"].addAmbience();
}

/* Generic Mission setup */

this.initMissionVariables = function(scenario) {
//		scenario = "1";
		missionVariables.rescuestation_prevreputation = missionVariables.rescuestation_reputation;
		missionVariables.rescuestation_scenario = scenario;
		missionVariables.rescuestation_stage = 1;
		worldScripts["Rescue Scenario "+scenario].initMissionVariables();

}

this.refuseCurrentMission = function () {
		this.availablescenarios.splice(this.missionpointer,1);
		//alter secondary board accordingly
		this.availablescenarios_save = this.availablescenarios.concat();
		//remove interface, if null missions
		if (this.availablescenarios.length === 0)
			player.ship.dockedStation.setInterface("rescue_station",null);
//		this.availablescenarios.shift(); // remove first mission from array
}

this.acceptMission = function () {
	//clear both boards
	this.availablescenarios = this.availablescenarios_save = new Array();
	//remove station interface
	player.ship.dockedStation.setInterface("rescue_station",null);
}

this.missionSuccess = function() {
		sckey = missionVariables.rescuestation_scenario;
		if (!this.missionlog[sckey+"_complete"]) {
				this.missionlog[sckey+"_complete"] = 1;
		} else {
				this.missionlog[sckey+"_complete"]++;
		}
		this.syncMissionLog();
		worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].missionSuccess();
		this.cleanupMission();
		this.fillMissionBoard();
}

this.failMission = function () {
		sckey = missionVariables.rescuestation_scenario;
		if (!this.missionlog[sckey+"_failed"]) {
				this.missionlog[sckey+"_failed"] = 1;
		} else {
				this.missionlog[sckey+"_failed"]++;
		}
		this.syncMissionLog();
		worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].failMission();
		this.cleanupMission(); // all for now
}

this.hasRankIncreased = function() {
		rold = missionVariables.rescuestation_prevreputation;
		rnew = missionVariables.rescuestation_reputation;
		if (rold < 320 && rnew >= 320) {
				return 6;
		} else if (rold < 160 && rnew >= 160) {
				return 5;
		} else if (rold < 80 && rnew >= 80) {
				return 4;
		} else if (rold < 40 && rnew >= 40) {
				return 3;
		} else if (rold < 20 && rnew >= 20) {
				return 2;
		} else if (rold < 10 && rnew >= 10) {
				return 1;
		}
		return 0;
}


this.reputationString = function() {
		rep = missionVariables.rescuestation_reputation;
		if (rep < -10) {
				return "rescue_rank_0";
		} else if (rep < 0) {
				return "rescue_rank_1";
		} else if (rep < 10) {
				return "rescue_rank_2";
		} else {
				grade = 2;
				while (rep >= 10) { // 10 20 40 80 160 320
						grade++;
						rep = rep/2;
				}
				return "rescue_rank_"+grade;
		}

}

this.cleanupMission = function() {

		if (missionVariables.rescuestation_startsystem) {
				mission.unmarkSystem(missionVariables.rescuestation_startsystem);
		}
		if (missionVariables.rescuestation_destsystem) {
				mission.unmarkSystem(missionVariables.rescuestation_destsystem);
		}
		if (missionVariables.rescuestation_system) {
				mission.unmarkSystem(missionVariables.rescuestation_system);
		}

		worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].cleanupMission();

		delete missionVariables.rescuestation_scenario;

		this.setMissionDetails(this.reputationString());

		missionVariables.rescuestation_stage = 0;
}

this.getDirection = function(here,destination) {
		d = -1;
		xdiff = destination.coordinates.x - here.coordinates.x;
		ydiff = here.coordinates.y - destination.coordinates.y;
		dir = Vector3D(xdiff,ydiff,0);
		res = "away";
		s = 1/Math.sqrt(2);
		if (dir.dot([0,1,0]) > d) { res = "north"; d = dir.dot([0,1,0]); }
		if (dir.dot([s,s,0]) > d) { res = "northeast"; d = dir.dot([s,s,0]); }
		if (dir.dot([1,0,0]) > d) { res = "east"; d = dir.dot([1,0,0]); }
		if (dir.dot([s,-s,0]) > d) { res = "southeast"; d = dir.dot([s,-s,0]); }
		if (dir.dot([0,-1,0]) > d) { res = "south"; d = dir.dot([0,-1,0]); }
		if (dir.dot([-s,-s,0]) > d) { res = "southwest"; d = dir.dot([-s,-s,0]); }
		if (dir.dot([-1,0,0]) > d) { res = "west"; d = dir.dot([-1,0,0]); }
		if (dir.dot([-s,s,0]) > d) { res = "northwest"; d = dir.dot([-s,s,0]); }

		return res;
}

this.rrsRandom = function(galid,sysid) {
// because we can't use scrambledPseudoRandomNumber for systems we aren't in
		n = (sysid+(galid*256))*23;
		n = (214013 * n + 2531011) & 0xFFFFFFFF;
    n = (214013 * n + 2531011) & 0xFFFFFFFF;
    n = (214013 * n + 2531011) & 0xFFFFFFFF;
		return n / 4294967296.0 + 0.5;
}

this.dangerScale = function(base) {
		if (!base) {
				base = 128;
		}
		danger = Math.floor(Math.random()*Math.floor(1+Math.sqrt(player.score/base)));
		return danger;
}


if (this.testmode != "") {
		this.shipTargetAcquired = function(target) {
				player.consoleMessage(target.name+" "+target.AI+" "+target.AIState+" "+target.script+" "+target.primaryRole);
		}
}
