this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim. 2014 spara"; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3.3"; 
this.name      = "Rescue Scenario 1a Derelict";
this.description = "Scripts for the Derelicts";

//1.3.3 typo fix
//1.3 random shipnames tweak -spara-

this.repairWait = function() {
		this.repairTimer = new Timer (this, this.repairDone, 15+(10*Math.random()));
}

this.whatamessMessage = function() {
		this.ship.commsMessage("[rescue_whatamess_"+missionVariables.rescuestation_scenario+"].");
}

this.repairDone = function() {
		this.ship.reactToAIMessage("REPAIR_NEXT");
		if (missionVariables.rescuestation_stage > 0) {
				missionVariables.rescuestation_stage++;
				if (missionVariables.rescuestation_stage == 14) {
						rocks = system.entitiesWithScanClass("CLASS_ROCK",this.ship,25E3);
						found = false;
						for (i=0;i<rocks.length;i++) {
								rock = rocks[i];
								if (rock.velocity.magnitude() > 0) {
										rock.scannerDisplayColor1 = "whiteColor";
										rock.scannerDisplayColor2 = "redColor";
										found = true;
								}
						}

						if (found) {
								this.ship.commsMessage("I'm detecting a few asteroids on a potential collision course. Sending co-ordinates to your scanners now.");
						}

				}
		}
}

this.repairsBegin = function() {
		if (Math.random()+(system.government/20) < 0.85) {
				this.attackTimer = new Timer (this, this.attackBegin, 3+(15*Math.random()));
		}
}

this.repairsEnd = function() {
	if (!worldScripts.randomshipnames)
		this.ship.displayName = this.ship.name+" (Rescued)";
}

this.attackBegin = function() {
		addpos = this.ship.position.add([0,0,23E3]); // from planetwards
		pirates = system.addShips("pirate",missionVariables.rescuestation_danger1+Math.floor(Math.random()*missionVariables.rescuestation_danger2),addpos,2E3);
		worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].forceAssault(pirates);
}

this.shipDied = function(whom,why) {
		if (whom == player.ship) {
				missionVariables.rescuestation_reputation -= 10;
		}

		player.consoleMessage("Rescue Mission: "+this.ship.displayName+" has been destroyed. Mission failed.");
		missionVariables.rescuestation_stage = 0;
		worldScripts["Rescue Stations"].failMission();
/*		if (whom) {
				player.consoleMessage(this.ship.displayName+" killed by "+whom.displayName+" using "+why);
		} else {
				player.consoleMessage(this.ship.displayName+" killed by anonymous using "+why);
		}*/
}

this.failedToFollow = function() {
		player.consoleMessage("Rescue Mission: "+this.ship.displayName+" has failed to enter witch-space. Mission failed.");
		missionVariables.rescuestation_stage = 0;
		worldScripts["Rescue Stations"].failMission();

}

this.energyFail = function() {
		if (this.ship.energy > 40) {
				this.ship.energy = 40;
		}
}

this.addToRescueGroup = function() {

		leader = system.shipsWithRole("arafura-mission",this.ship,25E3);
//		player.consoleMessage("Multiple leaders? ("+leader.length+")");
		if (leader.length >= 1) {
				this.target = leader[0];
//				this.ship.commsMessage("Ready to go");
				leader[0].reactToAIMessage("READY_TO_GO");
				if (missionVariables.rescuestation_stage > 0 && missionVariables.rescuestation_stage < 90) {
						missionVariables.rescuestation_stage = 90;
				}
				this.ship.reactToAIMessage("LEADER_FOUND");
				this.ship.savedCoordinates = leader[0].position;
		} else {
				this.ship.reactToAIMessage("NO_LEADER_FOUND");
		}

}

this.checkSystem = function() {
		if (missionVariables.rescuestation_stage < 100) {
				this.ship.reactToAIMessage("REMOTE_SYSTEM");
		} else {
				this.ship.reactToAIMessage("HOME_SYSTEM");
		}
}

this.inboundJump = function() {
		this.ship.fuel = 7;
		if (!this.ship.exitSystem(missionVariables.rescuestation_startsystem)) {
				this.ship.reactToAIMessage("JUMP_FAILED");
		}
}


this.locateArafura = function() {
		arafura = system.shipsWithRole("arafura-mission");
		if (arafura.length == 0) {
				this.ship.reactToAIMessage("NO_ARAFURA_FOUND");
		} else {
				station = system.shipsWithRole("rescue_station",this.ship,20000);
				if (station.length > 0) {
						this.ship.reactToAIMessage("STATION_NEARBY");
				}

				this.ship.savedCoordinates = arafura[0].position;
				this.ship.reactToAIMessage("ARAFURA_FOUND");
		}
}

this.locateHomeStation = function() {
		station = system.shipsWithRole("rescue_station");
		if (station.length == 0) {
				this.ship.reactToAIMessage("NO_HOME_STATION");
		} else {
				if (this.ship.position.distanceTo(station[0].position) < 20000) {
						this.ship.target = station[0];
				}
				this.ship.savedCoordinates = station[0].position;
				this.ship.reactToAIMessage("HOME_STATION");
		}
}

this.shipDockedWithStation = function(station) {
		if (missionVariables.rescuestation_stage >= 100) {
				missionVariables.rescuestation_derelict_home = 1;
				if (missionVariables.rescuestation_leader_home == 1) {
						missionVariables.rescuestation_stage = 1000;
						station.commsMessage("Thank you for your services, Commander [commander_name]. Please dock to receive payment.");
				}
		} else if (missionVariables.rescuestation_stage > 0) {
				player.consoleMessage("Rescue Mission: "+this.ship.displayName+" has not reached the rescue station. Mission aborted.");
				worldScripts["Rescue Stations"].failMission();
		}
}


this.fakeHyperJump = function() {
		// if the player jumps out first it seems a bit random whether this one manages to follow
		this.ship.exitSystem(missionVariables.rescuestation_startsystem);
}

this.shipTakingDamage = function(amount,whom,type) {
		if (type == "scrape damage" && (whom.hasRole("arafura-mission"))) {
				this.ship.energy += amount; // cancel damage from collision with leader
		}
}

this.shipExitedWormhole = function() {
// try to reduce collisions from following
//		this.ship.position = this.ship.position.add([-3E3,-3E3,-3E3]);
}
