this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name      = "Rescue Scenario 1 Leader";
this.description = "AI for the Moray Rescue Leader";

//1.3 changed shipname to random shipnames style -spara-

this.escortnum = 2;
this.playercallsign = "";
this.damagelevel = 0;

this.entryCheckMissionState = function() {
		if (this.ship.displayName.indexOf(":") === -1) {
			this.ship.displayName = this.ship.displayName + ": " + missionVariables.rescuestation_wingname + " Leader";
		}
		if (this.ship.escorts) {
				for (i=0;i<this.ship.escorts.length;i++) {
						if (this.escortnum == 4) {
								this.escortnum++; // 4 is player
						}
						escortship = this.ship.escorts[i]
						if (escortship.displayName.indexOf(":") === -1) {
								escortship.displayName = escortship.displayName + ": " + missionVariables.rescuestation_wingname+" "+(this.escortnum++);
						}
				}
		}

		if (missionVariables.rescuestation_stage == 0) {
				this.ship.reactToAIMessage("RETURN_TO_BASE");
		} else if (missionVariables.rescuestation_stage < 10) {
				this.ship.reactToAIMessage("READY_TO_LEAVE");
		} else if (missionVariables.rescuestation_stage < 100) {
				this.ship.reactToAIMessage("IN_SYSTEM");
		} else {
				this.ship.reactToAIMessage("RETURN_TO_BASE");
		}
}

this.beginMission = function() {
		missionVariables.rescuestation_callsign = missionVariables.rescuestation_wingname+" 4";
		
		this.ship.commsMessage("Welcome, Commander "+player.name+". You will be taking the "+missionVariables.rescuestation_callsign+" flight position for this trip. Form up in preparation for witch-space jump.",player.ship);
		missionVariables.rescuestation_stage = 4;
}

this.checkEscortsNear = function () {
		maxdistance = this.ship.position.distanceTo(player.ship.position);
		if (this.ship.escorts) {
				for (i=0;i<this.ship.escorts.length;i++) {
						escortship = this.ship.escorts[i]
						distance = this.ship.position.distanceTo(escortship.position);
						if (distance < 25E3) { // ignore those outside scanner range
								if (distance > maxdistance) {
										maxdistance = distance;
								}
						}
				}
		}
		if (maxdistance > 5000) {
				this.ship.reactToAIMessage("ESCORTS_FAR");
		} else {
				this.ship.reactToAIMessage("ESCORTS_NEAR");
		}
}
		
this.recallEscortsForJump = function() {
		this.ship.commsMessage("Preparing for witch-space jump. All "+missionVariables.rescuestation_wingname+"s, approach to within 5km.",player.ship);
		this.recallEscorts();

		this.setOutboundJumpCoordinates();
}

this.setOutboundJumpCoordinates = function() {
		station = system.shipsWithPrimaryRole("rescue_station",this.ship,25600);
		if (station.length > 0) {
				this.ship.savedCoordinates = station[0].position.add([0,0,-8E3]);

		} else {
				this.ship.savedCoordinates = player.ship.position;
		}
}

this.setDestinationToPlayer = function() {
		this.ship.savedCoordinates=player.ship.position;
}

this.keepEscortsClose = function() {
		// if any escort is more than 20km away, send it a recall message
		if (this.ship.escorts) {
				for (i=0;i<this.ship.escorts.length;i++) {
						escortship = this.ship.escorts[i];
						if (
								(escortship.target && 
								 (
										 (this.ship.position.distanceTo(escortship.position) > 20E3 &&
											this.ship.position.distanceTo(escortship.target.position) > 20E3
										 ) ||
												 this.ship.position.distanceTo(escortship.target.position) > 26E3
								 )
								) || 
										(!escortship.target && this.ship.position.distanceTo(escortship.position) > 10E3)
						) {
								this.recallEscort(escortship);
						}
				}		
		}
}

this.recallEscort = function(escortship) {
		if (escortship.AI == "interceptAI.plist") {
				this.ship.commsMessage(escortship.displayName+", return to escort formation.");
				escortship.exitAI(); // return to escorting
		}
}

this.recallEscorts = function() {
				if (this.ship.escorts) {
		for (i=0;i<this.ship.escorts.length;i++) {
				escortship = this.ship.escorts[i];
				this.recallEscort(escortship);
		}		
				}
}

this.prepareOutboundJump = function() {
		this.ship.commsMessage("Initialising witch-space jump to "+missionVariables.rescuestation_destsystem_name+". All "+missionVariables.rescuestation_wingname+"s, follow me.",player.ship);
		this.ship.reactToAIMessage("JUMP_READY");
}

this.outboundJump = function() {
		this.ship.fuel = 7;
		if (!this.ship.exitSystem(missionVariables.rescuestation_destsystem)) {
				this.ship.reactToAIMessage("JUMP_FAILED");
		} else {
				missionVariables.rescuestation_stage = 10; // second stage of mission
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].followToDest(this.ship.mass);
		}
}

this.inboundJump = function() {
		this.ship.fuel = 7;
		derelict = system.shipsWithRole(missionVariables.rescuestation_shiprole);
		if (derelict.length == 0) {
				this.ship.reactToAIMessage("NO_DERELICT");
		} else {
				this.ship.group = new ShipGroup("rescuegroup",this.ship);
				this.ship.group.addShip(this.ship);
				this.ship.group.addShip(derelict[0]);
		}

		if (!this.ship.exitSystem(missionVariables.rescuestation_startsystem)) {
				this.ship.reactToAIMessage("JUMP_FAILED");
		} else {
				missionVariables.rescuestation_stage = 100; // second stage of mission
				worldScripts["Rescue Scenario "+missionVariables.rescuestation_scenario].followToDest(this.ship.mass);
		}
}


this.jumpFailed = function() {
		if (Math.random() < 0.2) {
				this.ship.commsMessage("Witch-space jump failed. Reinitialising...",player.ship);
		}
}

this.shipExitedWormhole = function() {
// try to reduce collisions from followers
//		this.ship.velocity = this.ship.velocity.add(this.ship.vectorForward.multiply(this.ship.maxSpeed));
//		this.ship.position = this.ship.position.add(this.ship.vectorForward.multiply(3E3));
}

this.stationLost = function() {
		player.consoleMessage("Rescue Mission: the rescue station has been destroyed. Don't expect any pay now.");
		missionVariables.rescuestation_stage = 0;
		worldScripts["Rescue Stations"].failMission();
}

this.shipDied = function(whom,why) {
		if (whom == player.ship) {
				missionVariables.rescuestation_reputation -= 20;
		}
		player.consoleMessage("Rescue Mission: "+this.ship.displayName+" has been destroyed. Mission failed.");
		missionVariables.rescuestation_stage = 0;
		worldScripts["Rescue Stations"].failMission();
		if (this.ship.escorts) {
				for (i=0;i<this.ship.escorts.length;i++) {
						escortship = this.ship.escorts[i]
						escortship.displayName = escortship.name; // remove designations
				}
		}
/*		if (whom) {
				player.consoleMessage(this.ship.displayName+" killed by "+whom.displayName+" using "+why);
		} else {
				player.consoleMessage(this.ship.displayName+" killed by anonymous using "+why);
		} */
}

this.clearRocks = function () {
		this.ship.commsMessage(missionVariables.rescuestation_callsign+", could you clear out some of these asteroids? Other escorts stay close to me for defence.",player.ship);
}

this.returnToMission = function () {
		this.ship.commsMessage("That's all of them. Return to flight formation.",player.ship);
		this.recallEscorts();
}

this.requireEscort = function () {
		missionVariables.rescuestation_livefire = 1;
		if (!this.ship.target) {
				return;
		}
		if (this.ship.target.isWeapon) {
				return; // gives some odd messages
		}
		if (this.ship.target.hasRole("thargon")) {
				mothership = system.shipsWithRole("thargoid-mothership",this.ship,25600);
				if (mothership.length > 0) {
						// escorts don't have great aim, so better if they go for the motherships
						this.ship.target = mothership[0];
				}
		}
		if (this.ship.isThargoid) {
				this.requireAllEscorts();
				return;
		}
		closest = 27E3;
		if (this.ship.escorts) {
				for (i=0;i<this.ship.escorts.length;i++) {
						escortship = this.ship.escorts[i]
						distance = this.ship.position.distanceTo(escortship.position);
						if (closest > distance) {
								requestship = escortship;
								closest = distance;
						}
				}
		}
		if (player.ship.position) {
				distance = this.ship.position.distanceTo(player.ship.position);
		} else {
				distance = 50E3;
		}
		if (closest > distance) {
				requestship = player.ship;
				requestname = escortship.displayName;
				closest = distance;
				if (missionVariables.rescuestation_stage > 0) {
						this.requirePlayerHelp();
				}
		} else if (closest < 27E3) {
				this.requireEscortHelp(requestship,false);
		} else {
				player.commsMessage(this.ship.displayname+": I'm under attack! All "+missionVariables.rescuestation_wingname+" return to scanner range immediately!");
		}
}

this.requireAllEscorts = function() {
		if (this.ship.escorts) {
				this.ship.commsMessage("All "+missionVariables.rescuestation_wingname+", target the "+this.ship.target.displayName+".");
				for (i=0;i<this.ship.escorts.length;i++) {
						escortship = this.ship.escorts[i]
						this.requireEscortHelp(escortship,true);
				}
		}
}

this.requirePlayerHelp = function() {
		if (this.ship.target && this.ship.target != player.ship.target) {
				this.ship.commsMessage(missionVariables.rescuestation_callsign+", target the "+this.ship.target.displayName+".");
		} else {
//				this.ship.commsMessage("We're under attack! "+missionVariables.rescuestation_callsign+", fire at will!");
		}
}

this.requireEscortHelp = function(escort,quiet) {
		if (escort.target != this.ship.target) {
				if (!quiet) {
						this.ship.commsMessage(escort.displayName+", target the "+this.ship.target.displayName+".");
				}
				escort.target = this.ship.target;
				escort.setAI("interceptAI.plist");
		}
}

this.takingDamage = function() {
		if (this.damagelevel == 0) {
				this.damagelevel = 1;
				this.ship.commsMessage("I'm taking substantial damage! "+missionVariables.rescuestation_callsign+", target the "+this.ship.target.displayName+" immediately!");
		}
}

this.takingHeavyDamage = function() {
		if (this.damagelevel < 2) {
				this.damagelevel = 2;
				this.ship.commsMessage("Energy banks are failing! Get these hostiles away from me!");
		}
}

this.resetDamageCounter = function() {
		this.damagelevel = 0;
}

this.checkEscortAlert = function() {
		if (player.alertCondition == 3 || player.alertHostiles) {
				attackers = system.filteredEntities(this,function(entity) {
						return (entity.target == player.ship) && entity.isShip && entity.hasHostileTarget;
				},this.ship,25600);
				if (attackers.length > 0) {
						this.ship.target = attackers[0];
				}
				this.ship.reactToAIMessage("PLAYER_RED");
		} else {
				if (this.ship.escorts) {
						for (i=0;i<this.ship.escorts.length;i++) {
								escortship = this.ship.escorts[i]
								attackers = system.filteredEntities(this,function(entity) {
										return (entity.target == escortship) && entity.isShip && entity.hasHostileTarget;
								},this.ship,25600);
								if (attackers.length > 0) {
										this.ship.target = attackers[0];
										this.ship.reactToAIMessage("ESCORT_RED");
										return;
								}
						}
				}
				this.ship.reactToAIMessage("PLAYER_OK");
		}
}

this.locateDerelict = function() {
		derelict = system.shipsWithRole(missionVariables.rescuestation_shiprole);
		if (derelict.length == 0) {
				this.ship.reactToAIMessage("NO_DERELICT");
		} else {
				this.ship.savedCoordinates = derelict[0].position;
				this.ship.reactToAIMessage("DERELICT_FOUND");
		}
}

this.generalChatter = function() {
		if (this.ship.escorts && Math.random() < 0.3) {
				speakerno = Math.floor(Math.random()*this.ship.escorts.length);
				speaker = this.ship.escorts[speakerno];
		} else {
				speaker = this.ship;
		}
		speaker.commsMessage("[rescue_radiochatter]");
}

this.launchEVA = function() {
		derelict = system.shipsWithRole(missionVariables.rescuestation_shiprole);
		if (derelict.length == 0) {
				this.ship.reactToAIMessage("NO_DERELICT");
		} else {
				this.ship.target = derelict[0];
				this.ship.awardEquipment("EQ_RESCUE_MISSILE");
				this.ship.fireMissile("EQ_RESCUE_MISSILE");
				this.ship.target = null; /* prevent really silly mission failure */
		}
}

this.locateHomeStation = function() {
		station = system.shipsWithRole("rescue_station");
		if (station.length == 0) {
				this.ship.reactToAIMessage("NO_HOME_STATION");
		} else {
				if (this.ship.position.distanceTo(station[0].position) < 20000) {
						this.ship.target = station[0];
				}
				this.ship.savedCoordinates = station[0].position;
				this.ship.reactToAIMessage("HOME_STATION");
		}
}

this.shipDockedWithStation = function(station) {
		if (missionVariables.rescuestation_stage >= 100) {
				missionVariables.rescuestation_leader_home = 1;
				if (missionVariables.rescuestation_derelict_home == 1) {
						missionVariables.rescuestation_stage = 1000;
						station.commsMessage("Thank you for your services, Commander [commander_name]. Please dock to receive payment.");
				}
		} else if (missionVariables.rescuestation_stage > 0) {
				player.consoleMessage("Rescue Mission: "+this.ship.displayName+" has docked before the mission is complete. Mission aborted.");
				worldScripts["Rescue Stations"].failMission();
		}
}

this.shipTakingDamage = function(amount,whom,type) {
		if (type == "scrape damage" && (whom.hasRole("rrs-escort") || whom.hasRole("rescue_target"))) {
				this.ship.energy += amount; // cancel damage from collision with follower
		}
}




/* Autopilot functions block */

this.autopilotModeReady = function() {
		this.autopilotwilling = 1;
}

this.autopilotModeOffline = function() {
		this.autopilotwilling = 0;
}

this.autopilotContinue = function() {
		worldScripts["Rescue Autopilot"].autopilotStep(this.ship);
}
