this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 1a"; 
this.description = "This script adds scenario 1 variant A rescue mission."; 

//1.3 added background images to mission screens -spara-
//1.3 random shipnames integration -spara-

this.scenarioID = "1a";

this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerVariant("1",this.scenarioID);
}

this.missionAvailableCount = function() {
		return 1;
}

this.missionAvailable = function() {
		if (worldScripts["Rescue Stations"].scenariosWon("1") == 0) {
				return false; // it's a little trickier, so not the first time
		}
		if (2*worldScripts["Rescue Stations"].scenariosWon("1a") > worldScripts["Rescue Stations"].scenariosWon("1")) {
				return false; // no more than 1 in 3
		}
		if (Math.random() < 0.4) {
				return true; // occasional replacement
		}
		return false;
}

this.initMissionVariables = function() {
		worldScripts["Rescue Scenario 1"].initMissionVariables();
}

this.rescue_shipDockedWithStation = function (rstation) {
		worldScripts["Rescue Scenario 1"].rescue_shipDockedWithStation(rstation);
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "URGENT: Rescue Mission Escorts Needed",
														messageKey: "rescue_scenario_1_mission_available",
														choicesKey: "rescue_scenario_urgent_mission_choices",
														model: missionVariables.rescuestation_shiprole,
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				if (missionVariables.rescuestation_livefire == 1) {
						reward = Math.round(reward*1.33);
						missionVariables.rescuestation_reward = reward;
				}
				player.credits += reward;

				mission.runScreen({title: "Rescue mission completed",
													 messageKey: "rescue_scenario_1_mission_complete",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();

		}
}


this.rescue_shipWillLaunchFromStation = function (rstation) {
		worldScripts["Rescue Scenario 1"].rescue_shipWillLaunchFromStation(rstation);
}


this.rescue_populatingSystem = function() {
		if (missionVariables.rescuestation_stage == 10 && missionVariables.rescuestation_destsystem == system.ID) {
				missionVariables.rescuestation_stage = 11;

				addpos = this.randomOffset(60E3);
				
				var addedShip = system.addShips(missionVariables.rescuestation_shiprole,1,addpos,1);

				if (worldScripts.randomshipnames)
					addedShip[0].displayName = missionVariables.rescuestation_shiprole2;
				else
					addedShip[0].displayName = addedShip[0].name + " (derelict)";
				
				this.addAsteroids(addpos);

				addpos2 = this.randomOffset(15E3);
				
				if (Math.random() < 0.75) {
						pirates = system.addShips("pirate",missionVariables.rescuestation_danger1+Math.floor(Math.random()*missionVariables.rescuestation_danger2),addpos2,3E3);
						this.forceAssault(pirates);
				}

		}
}

/* Mission setup */

this.missionSuccess = function() {
		missionVariables.rescuestation_reputation += 5;
		if (missionVariables.rescuestation_livefire == 1) {
				missionVariables.rescuestation_reputation += 5;
		}
		// nothing special		
}

this.failMission = function () {
		missionVariables.rescuestation_reputation -= 5;
		// nothing special
}

this.cleanupMission = function() {
		worldScripts["Rescue Scenario 1"].cleanupMission();
}

this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Downloading mission data",
													 messageKey: "rescue_scenario_1_mission_accepted",
													 choicesKey: "rescue_scenario_urgent_mission_launch",
													 model: "rescue_team_lead",
													 background: "rrsfl_blank_bg.png"},
													worldScripts["Rescue Scenario 1"].missionOfferAccepted
												 );
		}
}

this.missionOfferAccepted = function (choice) {
		worldScripts["Rescue Stations"].acceptMission();
		worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_1_description");
		player.ship.fuel = 7;
		player.ship.launch();
}

/* Mission functions */

this.followToDest = function(mass) {
		expirytime = 50 + (mass/4000);
		this.followtimer = new Timer (this, this.checkFollowed, expirytime);
}

this.checkFollowed = function() {
		worldScripts["Rescue Scenario 1"].checkFollowed();
}

this.forceAssault = function(attackers) {
		worldScripts["Rescue Scenario 1"].forceAssault(attackers);
}

this.randomOffset = function(basedist) {
		return worldScripts["Rescue Scenario 1"].randomOffset(basedist);
}

this.addAsteroids = function(dpos) {
		cpos = dpos.add(Vector3D.random(5E3));
		asteroids = 100;
		fieldradius = 30E3;
		for (i=0;i<asteroids;i++) {
				apos = cpos.add(Vector3D.randomDirectionAndLength(fieldradius));
				aster = system.addShips("asteroid",1,apos,1E3);

				if (aster[0].position.distanceTo(dpos) > 20E3 && Math.random() < 0.5) {
						vel = dpos.subtract(aster[0].position);
						
						aster[0].velocity = vel.multiply((2+(Math.random()*9))/(5E3));
				}
		}

		

}
