this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 2"; 
this.description = "This script adds scenario 2 rescue mission."; 

//1.3 added background images to mission screens -spara-

this.scenarioID = "2";

this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerScenario(this.scenarioID);
}

this.missionAvailableCount = function() {
		return 1;
}

this.missionAvailable = function() {
		if (missionVariables.rescuestation_reputation < -10) {
				return false; // bad reputation
		}
		if (player.bounty > 50) {
				return false; // no fugitives
		}
		if (Math.random() < 0.5) {
				return true; // often available
		}
		return false;
}

this.initMissionVariables = function() {
		missionVariables.rescuestation_reward = 30;
		missionVariables.rescuestation_system = system.ID;
}

this.rescue_shipDockedWithStation = function (rstation) {
		
		if (rstation.isMainStation && system.ID == missionVariables.rescuestation_system && missionVariables.rescuestation_stage == 2) {
				missionVariables.rescuestation_stage = 1000;
		}
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Package delivery needed",
														messageKey: "rescue_scenario_2_mission_available",
														choicesKey: "rescue_scenario_nonurgent_mission_choices",
														model: "rescue_station",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				player.credits += reward;

				mission.runScreen({title: "Delivery completed",
													 messageKey: "rescue_scenario_2_mission_complete",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();

		}
}


this.rescue_shipWillLaunchFromStation = function (rstation) {

}


this.rescue_shipWillExitWitchspace = function() {
		player.consoleMessage("You were supposed to deliver a package before leaving the system!");
		worldScripts["Rescue Stations"].failMission();
}

/* Mission setup */

this.missionSuccess = function() {
		missionVariables.rescuestation_reputation += 2; // only really useful for complete beginners and restoring a damaged reputation
		// nothing special		
}

this.failMission = function () {
		missionVariables.rescuestation_reputation -= 10; // how can you get this one wrong!
}

this.cleanupMission = function() {
		delete missionVariables.rescuestation_reward;
		delete missionVariables.rescuestation_system;
}


this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Transferring package",
													 messageKey: "rescue_scenario_2_mission_accepted",
													 model: "alloy",
													 background: "rrsfl_blank_bg.png"},
													function (choice) {
															worldScripts["Rescue Stations"].acceptMission();
															worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_2_description");
													}
												 );
		}
}

/* Mission functions */

