this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 2a"; 
this.description = "This script adds scenario 2 variant A delivery mission."; 

//1.3 added background images to mission screens -spara-

this.scenarioID = "2a";


this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerVariant("2",this.scenarioID);
}

this.missionAvailable = function() {
		if (missionVariables.rescuestation_reputation < 10) {
				return false; // not enough reputation
		}
		if (player.bounty > 50) {
				return false; // no fugitives
		}
		if (Math.random() < 0.8) {
				return true; // generally replace if the player's rep is high enough
		}
		return false;
}

this.initMissionVariables = function() {
		missionVariables.rescuestation_reward = 150;
		missionVariables.rescuestation_system = system.ID;
		missionVariables.rescuestation_deadline = clock.seconds+7200; // 2 hours
}

this.rescue_shipDockedWithStation = function (rstation) {

		if (rstation.isMainStation && system.ID == missionVariables.rescuestation_system && missionVariables.rescuestation_stage == 3) {
				if (clock.seconds < missionVariables.rescuestation_deadline) {
						missionVariables.rescuestation_stage = 1000;
				} else {
						missionVariables.rescuestation_stage = 1001;
				}
		}
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Package delivery needed",
														messageKey: "rescue_scenario_2a_mission_available",
														choicesKey: "rescue_scenario_nonurgent_mission_choices",
														model: "rescue_station",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				player.credits += reward;

				mission.runScreen({title: "Delivery completed",
													 messageKey: "rescue_scenario_2a_mission_complete",
													 model: "rescue_blackbox",
													 background: "rrsfl_blank_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();

		} else if (missionVariables.rescuestation_stage == 1001) {
				mission.runScreen({title: "You have arrived too late",
													 messageKey: "rescue_scenario_2a_mission_toolate",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].failMission();

		}

}

this.rescue_shipWillExitWitchspace = function () {
		worldScripts["Rescue Scenario 2"].rescue_shipWillExitWitchspace();
}

this.missionSuccess = function() {
		missionVariables.rescuestation_reputation += 10;
		// nothing special		

		worldScripts["Rescue News"].sendNews("rescue_scenario_2a_news",1,0.02);

}

this.failMission = function () {
		missionVariables.rescuestation_reputation -= 10; 
}

this.cleanupMission = function() {
		delete missionVariables.rescuestation_reward;
		delete missionVariables.rescuestation_deadline;
		delete missionVariables.rescuestation_system;
}

this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Transferring package",
													 messageKey: "rescue_scenario_2a_mission_accepted",
													 model: "rescue_blackbox",
													 background: "rrsfl_blank_bg.png"},
													function (choice) {
															worldScripts["Rescue Stations"].acceptMission();
															worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_2a_description");
													}
												 );
		}
}

this.rescue_shipWillLaunchFromStation = function (rstation) {
		if (missionVariables.rescuestation_stage == 2 && rstation.hasRole("rescue_station")) {
				missionVariables.rescuestation_stage = 3;

				nhunters = 2+worldScripts["Rescue Stations"].dangerScale(128); 

				hunters = system.addShipsToRoute("rrs-vicious-hunter",nhunters,0.85,"wp");
				for(i=0;i<hunters.length;i++) {
						hunters[i].switchAI("rescue_player_hunterAI.plist");
						hunters[i].setScript("rrs_player_hunter.js");
						hunters[i].awardEquipment("EQ_FUEL_INJECTION");
						hunters[i].fuel = 7;
//						hunters[i].displayName = hunters[i].name+" (hunter)";
				}

		}

}


/* Mission functions */

