this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 2b"; 
this.description = "This script adds scenario 2, variant B solar lab mission."; 

//1.3 updated pylon equipment removal
//1.3 added background images to mission screens -spara-

this.scenarioID = "2b";


this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerVariant("2",this.scenarioID);
}

this.missionAvailable = function() {
		if (missionVariables.rescuestation_reputation < 0) {
				return false; // not enough reputation
		}
		if (player.ship.missileCapacity == 0) {
				return false; // no point if no missiles can be carried
		}
		if (player.bounty > 50) {
				return false; // no fugitives
		}
		if (player.credits < 80) {
				return false; // must be able to pay the deposit.
		}
		if (Math.random() < 0.3) {
				return true; // sometimes available
		}
		return false;
}

this.initMissionVariables = function() {
		missionVariables.rescuestation_reward = 75;
		missionVariables.rescuestation_system = system.ID;
		missionVariables.rescuestation_deadline = clock.seconds+14400; // 4 hours
}

this.rescue_shipDockedWithStation = function (rstation) {

		if (rstation.hasRole("rescue_station") && system.ID == missionVariables.rescuestation_system && missionVariables.rescuestation_stage == 100) {
				if (player.ship.equipmentStatus("EQ_RRS_SOLAR_MINE") == "EQUIPMENT_OK") {
						if (clock.seconds < missionVariables.rescuestation_deadline) {
								missionVariables.rescuestation_stage = 1000;
						} else {
								missionVariables.rescuestation_stage = 1001;
						}
						this.removeSolarMine();
				} else {
						player.consoleMessage("You seem to have lost the laboratory somewhere.");
						worldScripts["Rescue Stations"].failMission();
				}
		} else if (rstation.hasRole("rescue_station") && system.ID == missionVariables.rescuestation_system && missionVariables.rescuestation_stage < 100 && clock.seconds >= missionVariables.rescuestation_deadline) {
				missionVariables.rescuestation_stage = 1001;
				this.removeSolarMine();
		}
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Portable solar laboratory deployment",
														messageKey: "rescue_scenario_2b_mission_available",
														choicesKey: "rescue_scenario_nonurgent_mission_choices",
														model: "EQ_RRS_SOLAR_MINE",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				player.credits += reward + 80; // repay equipment deposit too

				mission.runScreen({title: "Laboratory returned",
													 messageKey: "rescue_scenario_2b_mission_complete",
													 model: "EQ_RRS_SOLAR_MINE",
													 background: "rrsfl_blank_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();

		} else if (missionVariables.rescuestation_stage == 1001) {
				player.credits += 80; // return deposit

				mission.runScreen({title: "Laboratory deadline missed",
													 messageKey: "rescue_scenario_2b_mission_toolate",
													 background: "rrsfl_bg.png"});
				worldScripts["Rescue Stations"].failMission();

		}

}

this.missionSuccess = function() {
		missionVariables.rescuestation_reputation += 4;
		// nothing special		
}

this.failMission = function () {
		missionVariables.rescuestation_reputation -= 10;
}

this.cleanupMission = function() {
		delete missionVariables.rescuestation_reward;
		delete missionVariables.rescuestation_deadline;
		delete missionVariables.rescuestation_system;
}

this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Mission accepted",
													 messageKey: "rescue_scenario_2b_mission_accepted",
													 model: "EQ_RRS_SOLAR_MINE",
													 background: "rrsfl_blank_bg.png"},
													function (choice) {
															worldScripts["Rescue Stations"].acceptMission();
															worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_2b_description");
															missionVariables.rescuestation_solarlabavailable = 1;
													}
												 );
		}
}

this.rescue_shipWillLaunchFromStation = function (rstation) {
		if (missionVariables.rescuestation_stage == 2 && rstation.hasRole("rescue_station")) {
				missionVariables.rescuestation_stage = 3;
				

		}

}

this.rescue_solarLabReactionComplete = function() {
		if (missionVariables.rescuestation_stage < 50) {
				missionVariables.rescuestation_stage = 50;
				player.commsMessage("RRS: Solar lab reaction complete. Please collect immediately.");
		}
}

this.rescue_solarLabCollected = function() {
		if (missionVariables.rescuestation_stage == 50) {
				missionVariables.rescuestation_stage = 100;
				player.consoleMessage("RRS Laboratory collected. Return it to the Waystation");
		}
}

this.rescue_solarLabDestroyed = function() {
		player.consoleMessage("RRS Laboratory destroyed. Mission failed.");
		worldScripts["Rescue Stations"].failMission();
}

this.rescue_solarLabDeployed = function() {
		if (missionVariables.rescuestation_stage < 50) {
				missionVariables.rescuestation_stage = 20;
				delete missionVariables.rescuestation_solarlabavailable;
		}
}

this.rescue_populatingSystem = function() {
		if (system.ID == missionVariables.rescuestation_system &&
				missionVariables.rescuestation_stage == 20 && 
				clock.seconds < missionVariables.rescuestation_deadline) {
// then there was a lab left behind. Don't know exactly where, but never mind
				rpos = system.sun.position.add(system.mainPlanet.position.subtract(system.sun.position).direction().multiply(system.sun.radius*2));
				lab = system.addShips("rrs_portable_solar_lab",1,rpos,1);
				lab[0].temperature = 0.65;
		}
}

/* Mission functions */

this.removeSolarMine = function() {
	player.ship.removeEquipment("EQ_RRS_SOLAR_MINE");
}

