this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 3"; 
this.description = "This script adds scenario 3 rescue mission."; 

//1.3 fixed description expand bug -spara-

this.scenarioID = "3";


this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerScenario(this.scenarioID);
}

this.missionAvailableCount = function() {
		if (Math.random() < 0.2) {
				return 1+this.missionAvailableCount();
		} else {
				return 1;
		}
}

this.missionAvailable = function() {
		if (Math.random() > 0.6) {
				return false; // usually available
		}
		if (missionVariables.rescuestation_reputation < 0) {
				return false; // need reasonable reputation
		}
		if (player.bounty > 50) {
				return false; // no fugitives
		}
/*		if (player.ship.equipmentStatus("EQ_FUEL_SCOOPS") != "EQUIPMENT_OK") {
				return false; // need a fuel scoop
		}
		if (player.ship.cargoSpaceCapacity < 1) {
				return false; // and somewhere to scoop to
		} */
		nearby = this.targetSystems();
		if (nearby.length < 1) {
				return false; // no suitable nearby systems
		}
		return true;
}

this.targetSystems = function() {
		return SystemInfo.filteredSystems(this, function (other) {
				if (!((other.systemID !== system.info.systemID) && 
						(!other.sun_gone_nova) &&
						(system.info.distanceToSystem(other) > 7) &&
							(system.info.distanceToSystem(other) < 15))) {
						return false;
				} else {
						var route = system.info.routeToSystem(other);
						return (route && route.distance <= 25);
				}
		});
}

this.initMissionVariables = function() {
		missionVariables.rescuestation_startsystem = system.ID;
		missionVariables.rescuestation_startsystem_name = system.name;

		nearby = this.targetSystems();
		destination = nearby[Math.floor(nearby.length*Math.random())];

		missionVariables.rescuestation_destsystem = destination.systemID;
		missionVariables.rescuestation_destsystem_name = destination.name;

		direction = worldScripts["Rescue Stations"].getDirection(system.info,destination);

		missionVariables.rescuestation_destsystem_desc = destination.name+" ("+expandDescription("[rescue_govname_"+destination.government+"]")+", "+Math.round(system.info.distanceToSystem(destination))+" LY "+direction+")";

		timer = (2.3+Math.random())*(system.info.routeToSystem(destination).time);
		deadline = clock.seconds+(timer*3600); // routeToSystem is in hours
// picked smallest number of jumps for timer, not quickest, to give a
// little flexibility

		missionVariables.rescuestation_deadline = deadline;
		missionVariables.rescuestation_deadline_text = clock.clockStringForTime(deadline);

		reward = Math.floor(system.info.routeToSystem(destination).distance * 30);
		missionVariables.rescuestation_reward = reward;


		danger1 = 0; danger2 = 0; // no ambush
		if (worldScripts["Rescue Stations"].scenariosWon("3") > 0) { // not the first time
				ambush = (Math.floor(Math.random()*10))-destination.government;
				if (ambush > 0) { // almost always in Anarchy, down to 20% in Corporate
						danger1 = 2 + worldScripts["Rescue Stations"].dangerScale(512); 
						danger2 = 3 + worldScripts["Rescue Stations"].dangerScale(256); 
						if (destination.government <= 1) {
								danger2++;
								if (destination.government == 0) {
										danger1++;
								}
						}
				}
		}
		missionVariables.rescuestation_danger1 = danger1;
		missionVariables.rescuestation_danger2 = danger2;

}

this.rescue_shipDockedWithStation = function (rstation) {
		
		if (rstation.hasRole("rescue_station") && system.ID == missionVariables.rescuestation_startsystem && missionVariables.rescuestation_stage == 100) {
				if (clock.seconds < missionVariables.rescuestation_deadline) {
						missionVariables.rescuestation_stage = 1000;
				} else {
						missionVariables.rescuestation_stage = 1001;
				}
		}
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Recover black box",
														messageKey: "rescue_scenario_3_mission_available",
														choicesKey: "rescue_scenario_nonurgent_mission_choices",
														model: "asteroid",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				debriefing = "rescue_scenario_3_mission_complete"
/*				if (missionVariables.rescuestation_danger1 > 0) {
						reward += 150;
						missionVariables.rescuestation_reward += 150;
						debriefing = "rescue_scenario_3_mission_complete_danger"
				} */
				player.credits += reward;

				mission.runScreen({title: "Black box recovered",
													 model: "rescue_blackbox",
													 messageKey: debriefing,
													 background: "rrsfl_blank_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();
		} else if (missionVariables.rescuestation_stage == 1001) {
				mission.runScreen({title: "Black box recovered",
													 messageKey: "rescue_scenario_3_mission_toolate",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].failMission();
				
		}
}


this.rescue_shipWillLaunchFromStation = function (rstation) {
		if (missionVariables.rescuestation_stage == 2 && system.ID == missionVariables.rescuestation_destsystem && missionVariables.rescuestation_deadline > clock.seconds) {
				this.makeAsteroidField();
				player.consoleMessage("That black box must be somewhere around here.",10);
		}
}


this.rescue_populatingSystem = function() {
		if (missionVariables.rescuestation_stage == 2 && system.ID == missionVariables.rescuestation_destsystem && missionVariables.rescuestation_deadline > clock.seconds) {
				this.makeAsteroidField();
				player.consoleMessage("That black box must be somewhere around here.",10);
		} else if (missionVariables.rescuestation_stage == 2 && missionVariables.rescuestation_deadline <= clock.seconds) {
				player.consoleMessage("You have taken too long to find the black box.",10);			
				worldScripts["Rescue Stations"].failMission();
		}
}

/* Mission setup */

this.missionSuccess = function() {
		mission.unmarkSystem(missionVariables.rescuestation_startsystem);
		missionVariables.rescuestation_reputation += 10;
		if (missionVariables.rescuestation_danger1 > 0) {
				missionVariables.rescuestation_reputation += 3;
		}

		// nothing special		
}

this.failMission = function () {
		if (missionVariables.rescuestation_stage > 100) {
				mission.unmarkSystem(missionVariables.rescuestation_destsystem);
		} else {
				mission.unmarkSystem(missionVariables.rescuestation_startsystem);
		}
		missionVariables.rescuestation_reputation -= 5; 
		if (missionVariables.rescuestation_stage != 1001) {
				missionVariables.rescuestation_reputation -= 5; // bringing it back at all does reduce the penalty
		}
}

this.cleanupMission = function() {
		delete missionVariables.rescuestation_reward;
		delete missionVariables.rescuestation_deadline;
		delete missionVariables.rescuestation_deadline_text;
		delete missionVariables.rescuestation_startsystem;
		delete missionVariables.rescuestation_startsystem_name;
		delete missionVariables.rescuestation_destsystem;
		delete missionVariables.rescuestation_destsystem_name;
		delete missionVariables.rescuestation_danger1;
		delete missionVariables.rescuestation_danger2;
}


this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Mission accepted",
													 messageKey: "rescue_scenario_3_mission_accepted",
													 model: "rescue_blackbox",
													 background: "rrsfl_blank_bg.png"},
													function (choice) {
															mission.markSystem(missionVariables.rescuestation_destsystem);
															worldScripts["Rescue Stations"].acceptMission();
															worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_3_description");
													}
												 );
		}
}

/* Mission functions */

this.makeAsteroidField = function() {
		if (system.shipsWithPrimaryRole("rescue_blackbox").length > 0) {
				return; // already done
		}
		

		fieldcentre = Vector3D(0,0,0.2+(Math.random()*0.3)).fromCoordinateSystem("wsu");
		fieldcentre.add(Vector3D.random(20E3));
		
		asteroids = 150;
		fieldradius = 20E3;
		for (i=0;i<asteroids;i++) {
				apos = fieldcentre.add(Vector3D.randomDirectionAndLength(fieldradius));
				system.addShips("asteroid",1,apos,1E3);
		}
		
		bb = system.addShips("rescue_blackbox",1,fieldcentre,5E3);

		if (missionVariables.rescuestation_danger1 > 0) {
				system.addShips("rrs_asteroid_ambusher",missionVariables.rescuestation_danger1+Math.floor(Math.random()*missionVariables.rescuestation_danger2),fieldcentre,15E3);
		} else {
				bbpos = bb[0].position;
				// if there aren't pirates, then there might be a few cargo pods left
				if (Math.random() < 0.75) {
						system.addShips("alloy",1+Math.floor(Math.random()*3),bbpos,300);
				}
				if (Math.random() < 0.5) {
						system.addShips("barrel",1+Math.floor(Math.random()*2),bbpos,300);
				}
		}

}

this.collectBox = function() {
		missionVariables.rescuestation_stage = 100;
		mission.unmarkSystem(missionVariables.rescuestation_destsystem);
		mission.markSystem(missionVariables.rescuestation_startsystem);
		
}
