this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 3a"; 
this.description = "This script adds scenario 3 variant A rescue mission."; 

//1.3 added background image to mission screens -spara-

this.scenarioID = "3a";


this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerVariant("3",this.scenarioID);
}

this.missionAvailableCount = function() {
		return 1;
}

// variant, only needs conditions extra to original
this.missionAvailable = function() {
		if (Math.random() < 0.4) {
				return true; // even if it can replace as variant, doesn't always
		}
		if (missionVariables.rescuestation_reputation < 20) {
				return false; // need reasonable reputation
		}
		if (worldScripts["Rescue Stations"].scenariosWon("3") == 0) {
				return false; // can't replace the first mission
		}
		replacer = Math.floor(worldScripts["Rescue Stations"].scenariosWon("3")/5);
		if (replacer < worldScripts["Rescue Stations"].scenariosWon("3a")) {
				return false; // at most 1 in 5 completed missions
		}
		return false;
}

this.initMissionVariables = function() {
		worldScripts["Rescue Scenario 3"].initMissionVariables();
		missionVariables.rescuestation_danger1 = 0; // never a sidewinder ambush in this variant
}

this.rescue_shipDockedWithStation = function (rstation) {
		worldScripts["Rescue Scenario 3"].rescue_shipDockedWithStation(rstation);
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Recover black box",
														messageKey: "rescue_scenario_3_mission_available",
														choicesKey: "rescue_scenario_nonurgent_mission_choices",
														model: "asteroid",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward * 1.5;
				debriefing = "rescue_scenario_3a_mission_complete"
				player.credits += reward;

				mission.runScreen({title: "Black box recovered",
													 model: "rescue_blackbox",
													 messageKey: debriefing,
													 background: "rrsfl_blank_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();
		} else if (missionVariables.rescuestation_stage == 1001) {
				mission.runScreen({title: "Black box recovered",
													 messageKey: "rescue_scenario_3_mission_toolate",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].failMission();
				
		}
}


this.rescue_shipWillLaunchFromStation = function (rstation) {
		worldScripts["Rescue Scenario 3"].rescue_shipWillLaunchFromStation();
}


this.rescue_populatingSystem = function() {
		if (missionVariables.rescuestation_stage == 2 && system.ID == missionVariables.rescuestation_destsystem && missionVariables.rescuestation_deadline > clock.seconds) {
				this.makeAsteroidField();
				player.consoleMessage("That black box must be somewhere around here.",10);
		} else if (missionVariables.rescuestation_stage == 2 && missionVariables.rescuestation_deadline <= clock.seconds) {
				player.consoleMessage("You have taken too long to find the black box.",10);			
				worldScripts["Rescue Stations"].failMission();
		} else if (missionVariables.rescuestation_stage >= 100 && system.ID != missionVariables.rescuestation_startsystem) {
				this.spawnAssassin();
		}
}

this.rescue_shipExitedWitchspace = function() {
		assassins = system.shipsWithPrimaryRole("rrs-vicious-hunter",player.ship,25600);
		if (assassins.length > 0) {
				assassins[0].commsMessage("[rescue_scenario_3a_conspirator_target]");
		}
		
}

/* Mission setup */

this.missionSuccess = function() {
		mission.unmarkSystem(missionVariables.rescuestation_startsystem);
		missionVariables.rescuestation_reputation += 15;

		worldScripts["Rescue News"].sendNews("rescue_scenario_3a_news",2,0.2);

		// nothing special		
}

this.failMission = function () {
		if (missionVariables.rescuestation_stage > 100) {
				mission.unmarkSystem(missionVariables.rescuestation_destsystem);
		} else {
				mission.unmarkSystem(missionVariables.rescuestation_startsystem);
		}
		missionVariables.rescuestation_reputation -= 5;
		if (missionVariables.rescuestation_stage != 1001) {
				missionVariables.rescuestation_reputation -= 5; // bringing it back at all does reduce the penalty
		}
}

this.cleanupMission = function() {
		worldScripts["Rescue Scenario 3"].cleanupMission();
}

this.missionOfferDecision = function (choice) {
		worldScripts["Rescue Scenario 3"].missionOfferDecision();
}

/* Mission functions */

this.makeAsteroidField = function() {
		worldScripts["Rescue Scenario 3"].makeAsteroidField();
}

this.collectBox = function() {
		worldScripts["Rescue Scenario 3"].collectBox();
}

this.spawnAssassin = function() {
		numass = 2+worldScripts["Rescue Stations"].dangerScale(128);

		assassins = system.addShips("rrs-vicious-hunter",numass,player.ship.position.add(Vector3D.random(14E3),1E3));
		for (i=0;i<assassins.length;i++) {
				assassin = assassins[i];
				assassin.target = player.ship;
				assassin.setAI("interceptAI.plist");
		}

}
