this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.3"; 
this.name        = "Rescue Scenario 5a"; 
this.description = "This script adds variant 5A rescue mission ."; 

//1.3 added background images to mission screens -spara-
//1.3 naming tweaks -spara-

this.scenarioID = "5a";
this.stagetimer = null;
this.notifytimer = null;

this.startUp = function() {
// make sure Rescue Stations is loaded first
		if (worldScripts["Rescue Stations"].startUp) {
				worldScripts["Rescue Stations"].startUp();
		}
		worldScripts["Rescue Stations"].registerVariant("5",this.scenarioID);
}


this.missionAvailable = function() {
		return false;
		if (missionVariables.rescuestation_reputation < 20) {
				return false; // insufficient reputation
		}
		if (worldScripts["Rescue Stations"].scenariosWon("5a") > worldScripts["Rescue Stations"].scenariosWon("5")) {
				return false; // not too many
		}
		if (Math.random() < 0.4) {
				return true; // often replaces
		}
		return false;
}

this.initMissionVariables = function() {
		missionVariables.rescuestation_reward = 350;
		missionVariables.rescuestation_system = system.ID;
		missionVariables.rescuestation_shipname = expandDescription("[rescue_wingnames]");
}

this.rescue_shipDockedWithStation = function (rstation) {
		
		if (rstation.hasRole("rescue_station") && system.ID == missionVariables.rescuestation_system && missionVariables.rescuestation_stage == 100) {
				missionVariables.rescuestation_stage = 1000;
		} else {
				if (missionVariables.rescuestation_stage > 1) {
						if (missionVariables.rescuestation_stage < 1000) {
								player.commsMessage("You have docked before the rescue mission was complete. You will not be paid for this breach of contract!",7);
								worldScripts["Rescue Stations"].failMission();
						}
				}
		}
}

this.rescue_missionScreenOpportunity = function() {
		if (missionVariables.rescuestation_stage == 1) {
				mission.runScreen ({title: "Emergency escort needed",
														messageKey: "rescue_scenario_5a_mission_available",
														choicesKey: "rescue_scenario_urgent_mission_choices",
														model: "rescue_station",
														background: "rrsfl_blank_bg.png"},
													 this.missionOfferDecision
													);
		} else if (missionVariables.rescuestation_stage == 1000) {
				reward = missionVariables.rescuestation_reward;
				player.credits += reward;

				mission.runScreen({title: "Escort mission completed",
													 messageKey: "rescue_scenario_5a_mission_complete",
													 background: "rrsfl_bg.png"});

				worldScripts["Rescue Stations"].missionSuccess();

		}
}

this.rescue_shipWillLaunchFromStation = function (rstation) {
		if (missionVariables.rescuestation_stage == 2 && rstation.hasRole("rescue_station")) {

				this.stagetimer = new Timer(this,this.insertArafura,150);
				this.notifytimer = new Timer(this,this.notifyDeadline,30);

				missionVariables.rescuestation_stage = 3;
		}

}

this.rescue_shipWillExitWitchspace = function() {
		if (missionVariables.rescuestation_stage < 100) {
				player.consoleMessage("You have abandoned the rescue mission");
				worldScripts["Rescue Stations"].failMission();
		}
}



/* Mission functions */

this.missionSuccess = function() {
		missionVariables.rescuestation_reputation += 10;
		// nothing special		
}

this.failMission = function () {
		missionVariables.rescuestation_reputation -= 5; // easy to fail through no fault of own
}

this.cleanupMission = function() {
		delete missionVariables.rescuestation_reward;
		delete missionVariables.rescuestation_system;
		delete missionVariables.rescuestation_shipname;
}

this.missionOfferDecision = function (choice) {
		if (choice == "NO") {
				worldScripts["Rescue Stations"].refuseCurrentMission();
				worldScripts["Rescue Stations"].cleanupMission();
				missionVariables.rescuestation_stage = 0;
		} else {
				missionVariables.rescuestation_stage = 2;
				mission.runScreen({title: "Downloading mission data",
													 messageKey: "rescue_scenario_5a_mission_accepted",
													 choicesKey: "rescue_scenario_urgent_mission_launch",
													 model: "rrs-escort",
													 background: "rrsfl_blank_bg.png"},
													worldScripts["Rescue Scenario 5a"].missionOfferAccepted
												 );
		}
}

this.missionOfferAccepted = function (choice) {
		worldScripts["Rescue Stations"].acceptMission();
		worldScripts["Rescue Stations"].setMissionDetails("rescue_scenario_5a_description");
		player.ship.fuel = 7;
		player.ship.launch();
}

this.notifyDeadline = function() {
		deadline = 5*Math.ceil(0.2*(this.stagetimer.nextTime - clock.absoluteSeconds));
		player.commsMessage("RRS: "+missionVariables.rescuestation_shipname+" wing ETA is "+deadline+" seconds");
		if (deadline > 30) {
				this.notifytimer = new Timer(this,this.notifyDeadline,30);				
		} else {
				this.notifytimer = new Timer(this,this.notifyDeadline,5);
		}
}

this.insertArafura = function() {
		arafura = system.addShips("arafura-returning",1,[0,0,0],5E3);
		
		this.notifytimer.stop();
		this.stagetimer = new Timer(this,this.insertOpposition,5+(10*Math.random()));

		arafura[0].displayName = arafura[0].displayName + ": " + missionVariables.rescuestation_shipname+" Leader";
		arafura[0].commsMessage("[rescue_introuble]");
		arafura[0].escorts[0].displayName = arafura[0].escorts[0].displayName + ": " + missionVariables.rescuestation_shipname+" "+(2+Math.floor(Math.random()*5));

}

this.insertOpposition = function() {
		opplevel = 2+worldScripts["Rescue Stations"].dangerScale(256);
		opptype = Math.random();
		if (opptype < 0.6) {
				opprole = "pirate";
				opplevel = opplevel*2;
		} else if (opptype < 0.9) {
				opprole = "rrs-vicious-hunter";
		} else if (opptype < 0.98) {
				opprole = "thargoid"; // just some basic ones
		} else {
				opprole = "thargoid-mothership"; // allow tougher thargoids from OXPs
				opplevel = Math.floor(opplevel*0.75);
		}
		if (opplevel < 1) {
				opplevel = 1;
		}

		
		pirates = system.addShips(opprole,opplevel,[0,0,0],5E3);
		if (!pirates) {
				log(this.name,"Couldn't add "+opprole);
		}

		arafura = system.shipsWithRole("arafura-returning");

		for(i=0;i<pirates.length;i++) {
				pirates[i].setScript("rescue_scenario_5_pirate.js");
				if (pirates[i].bounty == 0) {
						pirates[i].bounty = 1+Math.floor(Math.random()*5);
						pirates[i].switchAI("pirateAI.plist");
				}
				if (pirates[i].escorts) {
						for (j=0;j<pirates[i].escorts.length;j++) {
								pirates[i].escorts[j].setScript("rescue_scenario_5_pirate.js");
						}
				}
				if (Math.random() < 0.5) {
						pirates[i].target = arafura[0];
				} else if (Math.random() < 0.5) {
						pirates[i].target = arafura[0].escorts[0];
				} else {
						pirates[i].target = player.ship;
				}
				if (!pirates[i].isThargoid) {
						pirates[i].setAI("interceptAI.plist");
				}
		}
		
		reinforce = Math.floor(opplevel/3);
		if (reinforce < 1) {
				reinforce = 1;
		} else if (reinforce > 4) {
				reinforce = 4;
		}
		rpos = player.ship.position.add(system.mainPlanet.position.direction().multiply(24E3));
				
		reinforcements = system.addShips("rrs-defender",reinforce,rpos,1E3);
		for (i=0;i<reinforcements.length;i++) {
				reinforcements[i].orientation = reinforcements[i].orientation.rotateY(Math.PI);
				reinforcements[i].target = pirates[Math.floor(Math.random()*pirates.length)];
				reinforcements[i].switchAI("policeInterceptAI.plist");
		}
		reinforcements[0].commsMessage("Reinforcements are coming! Keep them off the Arafura until we arrive, then we'll cover your escape.");
		
}
