this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.2.4"; 
this.name = "RRS Formation Flight Autopilot";
this.description = "An autopilot for those boring escort bits";

this.equipmentactive = 0;
this.checkstatus = undefined;
this.autotarget = undefined;
this.music = "uranus.ogg";

this.activated = function() {
		if (this.equipmentactive == 0) {
				if (system.shipsWithRole("rrs-autopilot-screen").length > 0) {
						player.consoleMessage("Please wait for subsystem reboot to complete");
						return;
				}
				this.autopilotOn();
		} else {
				this.autopilotOff();
		}
}

this.autopilotAvailable = function() {
		if (player.ship.equipmentStatus("EQ_DOCK_COMP") != "EQUIPMENT_OK") {
				return "Severe damage to autopilot computers";
		} else if (player.alertCondition == 0) {
				return "Cannot be used while docked";
		} else if (player.alertCondition == 3) {
				return "Cannot be used while at red alert";
		} else if (player.alertEnergy) {
				return "Energy banks are not full";
		} else if (!player.ship.target) {
				return "Select mothership to follow as target";
		} else if (!player.ship.target.hasRole("rrs-flightcomp-supported")) {
				return "Selected target does not support this equipment";
		} else if (!player.ship.target.script.autopilotwilling) {
				return "Selected target is not currently transmitting";
		} else if (player.ship.target.savedCoordinates.distanceTo(player.ship.target.position) < 25E3) {
				return "Selected target already in destination vicinity";
		} else {

				range = player.ship.position.distanceTo(player.ship.target.position);
				speedmatch = player.ship.velocity.magnitude()/player.ship.target.velocity.magnitude();
				headmatch = player.ship.velocity.direction().dot(player.ship.target.velocity.direction());

				if (range > 25E2) {
						return "Approach to within 2500m of selected target";
				} else if (range < 5E2) {
						return "Withdraw to at least 500m away from selected target";
				} else if (speedmatch < 0.9) {
						return "Accelerate to match target speed";
				} else if (speedmatch > 1.1) {
						return "Decelerate to match target speed";
				} else if (headmatch < 0.99) {
						return "Turn to match target heading";
				} else {
						return "READY";
				}
		}
}

this.autopilotOn = function() {
		available = this.autopilotAvailable();
		if (available == "READY") {
				this.autopilotActive();
		} else {
				player.consoleMessage(available,5);
				player.consoleMessage("Please fix error and then reactivate",5);
		}
}

this.autopilotActive = function() {
		this.equipmentactive = 1;
		this.autotarget = player.ship.target;
		this.checkstatus = new Timer(this,this.autopilotCheckState,3);
		player.ship.target.reactToAIMessage("PLAYER_ESCORT_AUTOPILOT_ON");
		player.consoleMessage("Autopilot initialising",5);
		screen = system.addShips("rrs-autopilot-screen",1,player.ship.position.add(player.ship.vectorUp.multiply(player.ship.collisionRadius*4)));
		screen[0].orientation = player.ship.orientation;
		screen[0].velocity = player.ship.velocity;
		Sound.playMusic(this.music);

}

this.autopilotCheckState = function() {
		if (this.equipmentactive != 1) {
				return;
		}
		available = this.autopilotAvailable();
		if (available == "READY") {
				player.ship.hudHidden = true;
				// schedule another check
				screen = system.shipsWithRole("rrs-autopilot-screen");
				screen[0].position = player.ship.position.add(player.ship.vectorUp.multiply(player.ship.collisionRadius*4));
				this.checkstatus = new Timer(this,this.autopilotCheckState,1);
		} else {
				player.consoleMessage("Exiting autopilot mode!");
				// quit autopilot
				this.autopilotOff();
		}
}

this.autopilotOff = function() {
		player.ship.hudHidden = false;
		Sound.stopMusic(this.music);
		if (this.equipmentactive == 0) {
				return;
		}
		this.equipmentactive = 0;
		screen = system.shipsWithRole("rrs-autopilot-screen");
		screen[0].remove(true);
//		worldScripts["Rescue Autopilot"].autopilotShutdown();
		if (this.checkstatus) {
				this.checkstatus.stop();
		}
		if (this.autotarget.isValid && this.autotarget.isShip) {
				this.autotarget.reactToAIMessage("PLAYER_ESCORT_AUTOPILOT_OFF");
		}
		this.autotarget = undefined;
		player.consoleMessage("Autopilot disengaged");
}

