this.author      = "cim"; 
this.copyright   = "� 2011-2012 cim."; 
this.licence = "CC-BY-SA 3.0";
this.version     = "1.2.4"; 
this.name = "RRS Solar Lab";
this.description = "Functions for the RRS portable Solar Laboratory";

this.lasttemp = -1;
this.reacted = 0;
this.started = 0;

this.replaceIfNeeded = function() {
		if (this.ship.primaryRole == "EQ_RRS_SOLAR_MINE") {
				p = this.ship.position;
				this.ship.remove(true);
				system.addShips("rrs_portable_solar_lab",1,p,1);
		} else {
				worldScripts["Rescue Stations"].solarLabDeployed();
		}
}

this.checkProgress = function() {
		temp = this.ship.temperature;
		if (this.lasttemp == -1) {
				this.lasttemp = temp;
				return; // first check
		}

		this.reacted = 1;
		this.reactionComplete();

//		log(this.name,"Temperature: "+temp);
		if (temp <= this.lasttemp && temp < 0.75) {
				this.ship.commsMessage("ERR#9: Too far from sun. Please collect and redeploy");
				this.lasttemp = temp;
				return; // first check
		}
		if (temp > 0.9) {
				this.ship.commsMessage("ERR#5: Thermal overload. Please collect immediately.");
		} else if (temp > 0.75) {
				if (!this.reacted) {
						this.reacted = 1;
						this.reactionComplete();
				}
		} else {
				if (!this.started) {
						this.ship.commsMessage("Processing in progress.");
						this.started = 1;
				}
		}
		this.lasttemp = temp;
}

this.reactionComplete = function() {
// check for mission success, use event handler
		worldScripts["Rescue Stations"].solarLabReactionComplete();
		this.ship.commsMessage("Reaction complete. Collect lab now.");
//		log(this.name,"Reaction completed");
}

this.shipDied = function() {
		worldScripts["Rescue Stations"].solarLabDestroyed();
}

this.shipWasScooped = function(scooper) {
		scooper.awardEquipment("EQ_RRS_SOLAR_MINE");
		worldScripts["Rescue Stations"].solarLabCollected(scooper);
}