"use strict";
this.name               = "ambusher_script";
this.author               = "spara";
this.copyright            = "2014 Mika Spåra";
this.description         = "RSS Ambusher shp script";
this.version            = "1.3";
this.licence     = "CC BY-NC-SA 3.0";

//Tumbling part from Smivs - 'rotateDerelict'. Code by Capt. Murphy.

this.shipSpawned = function() {
	this.rotateAmbushTimer = new Timer(this, this.rotateAmbush,3); // timer to start derelict rotation after 3 seconds
	delete this.shipSpawned;
}

this.rotateAmbush = function(){
 this.rotateVector = Vector3D.randomDirection(); // creates a random axis of rotation.
 this.rotateSpeedFactor = (Math.random() * (0.05) + 0.05); // creates a random rotate speed factor between 0.05 and 0.1 - 0.1 will result in a rotation speed of approx 1 full rotation every 63 seconds, 0.05 in a rotation speed of approx 1 full rotation every 126 seconds.
 this.rotateAmbushCallback = addFrameCallback(this.rotateFunction.bind(this)); // create FrameCallback
}

// delta is the time in game seconds since the last frame.
this.rotateFunction = function(delta) {
	if (!this.ship.isValid){
		removeFrameCallback(this.rotateAmbushCallback);
		delete this.rotateAmbushCallback;return;
	} // end FrameCallback is ship has died;
 if (delta === 0){return;} // do nothing if game is paused;
 var newOrientation = this.ship.orientation.rotate(this.rotateVector,delta*this.rotateSpeedFactor); // calculates new orientation, using delta as a factor so that rotation speed is constant across varying frame rates. delta*this.rotateSpeedFactor is a value in radians. There are approx 6.3 radians in a full rotation.
 this.ship.orientation = newOrientation; // applies new orientation;
}

this.activateAmbush = function() {
	//stop tumbling
	removeFrameCallback(this.rotateAmbushCallback);
	delete this.rotateAmbushCallback;
	//turn up the lights
	this.ship.subEntities[0].setMaterials({"bbs_sidewinder_emission.png": {diffuse_map: "rrsfl_asteroid_sidewinder_e.png", emission_map: "rrsfl_asteroid_sidewinder_emission-lights.png", emission_modulate_color: (255, 252, 200, 0.75)}}); //colors the cockpit, navlights and engines only
	//set correct ai
	this.ship.setAI("interceptAI.plist");
	//name her
	if (worldScripts.randomshipnames) 
		this.ship.displayName = this.ship.name + ": " + worldScripts.randomshipnames.$randomPirateName(this.ship);
	else this.ship.displayName = this.ship.name;
	//correct scan class
	this.ship.scanClass = "CLASS_NEUTRAL";
}

